<?php
ob_start('ob_gzhandler');

require '../../require/vendor/autoload.php';

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
$DBhost = "localhost";
$DBusername = "cpvarbia_inspection";
$DBpassword = "CCv4XYNkYG9C";
$DBname = "cpvarbia_inspection";
$mysqli = new mysqli("$DBhost", "$DBusername", "$DBpassword", "$DBname");

$DBhost1 = "localhost";
$DBusername1 = "cpvarbia_inspection";
$DBpassword1 = "CCv4XYNkYG9C";
$DBname1 = "cpvarbia_rd0";

$mysqli1 = new mysqli("$DBhost1", "$DBusername1", "$DBpassword1", "$DBname1");

if ($mysqli->connect_errno) {
  echo "Failed to connect to MySQL: " . $mysqli->connect_error;
  exit();
}
if ($mysqli1->connect_errno) {
  echo "Failed to connect to MySQL: " . $mysqli1->connect_error;
  exit();
}
$mysqli->query("SET character_set_client=utf8");
$mysqli->query("SET character_set_connection=utf8");
$mysqli->query("SET character_set_database=utf8");
$mysqli->query("SET character_set_results=utf8");
$mysqli->query("SET character_set_server=utf8");
date_default_timezone_set("Asia/Riyadh");
$TodayIs = date("Y-m-d H:i:s");

$StartDate = $_GET['StartDate'];
$EndDate = $_GET['EndDate'];
function haversineDistance($point1, $point2, $unit = 'kilometers') {
    // Extract latitude and longitude from the points
    list($lat1, $lon1) = $point1;
    list($lat2, $lon2) = $point2;

    // Convert latitude and longitude from degrees to radians
    $lat1 = deg2rad($lat1);
    $lon1 = deg2rad($lon1);
    $lat2 = deg2rad($lat2);
    $lon2 = deg2rad($lon2);

    // Calculate the change in coordinates
    $deltaLat = $lat2 - $lat1;
    $deltaLon = $lon2 - $lon1;

    // Haversine formula
    $a = sin($deltaLat / 2) * sin($deltaLat / 2) + cos($lat1) * cos($lat2) * sin($deltaLon / 2) * sin($deltaLon / 2);
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    // Earth's radius in kilometers
    $earthRadius = 6371; // kilometers

    // Calculate the distance
    $distance = $earthRadius * $c;

    return $distance;
}
  $spreadsheet = new Spreadsheet();
$sheet = $spreadsheet->getActiveSheet();
$sheet->setCellValue('A1', 'PStageID');
$sheet->setCellValue('B1', 'ReferenceNo');
$sheet->setCellValue('C1', 'StageName');
$sheet->setCellValue('D1', 'StageDate');
$sheet->setCellValue('E1', 'name');
$sheet->setCellValue('F1', 'Region');
$sheet->setCellValue('G1', 'Location');
$sheet->setCellValue('H1', 'AccurateLocation');
$sheet->setCellValue('I1', 'distance');
$sheet->setCellValue('J1', 'in 1 KM');
  $rowNum = 2;
$RD5s = $mysqli->query("SELECT project_stages.`PStageID`,project_stages.`StageDate`,project_stages.`Location`, projects.ReferenceNo, users.Email, stages.StageName FROM `project_stages`, projects,users,stages WHERE`project_stages`.`ProjectID` = projects.ProjectID and project_stages.InspectorID = users.UserID and project_stages.StageID = stages.StageID and `StageDate` BETWEEN  '$StartDate 00:00:00' and '$EndDate 23:59:59' and project_stages.Synced = '1' and project_stages.Deleted= '0'");
while ($RD5 = mysqli_fetch_array($RD5s)) {

  if (count($RD5) > 0) {
  

      $res88 = $mysqli1->query("SELECT * FROM `users` WHERE `Email` = '" . $RD5['Email'] . "' ");
      $row88 = mysqli_fetch_array($res88);
      
      
      $res898 = $mysqli1->query("SELECT org_chart.Name FROM `user_chart`,org_chart WHERE `user_chart`.`OCUID` = org_chart.OCID and user_chart.UserID = '" . $row88['UserID'] . "' ");
      $row898 = mysqli_fetch_array($res898);

      $res7 = $mysqli1->query("SELECT `ProjectID` FROM `projects` WHERE `ReferenceNo` = '".$RD5['ReferenceNo']."' ");
      $row7 = mysqli_fetch_array($res7);
      $RD0ProjectID = $row7['ProjectID'];

      $res3 = $mysqli1->query("SELECT AccurateLocation  FROM `project_locations` WHERE `AccurateLocation` IS NOT NULL and `ProjectID` = '$RD0ProjectID'");
      $numrows3 = mysqli_num_rows($res3);
      if ($numrows3 > 0) {
        $row3 = mysqli_fetch_array($res3);

        $AccurateLocation = str_replace('|', ',', $row3['AccurateLocation']);

        $LocationArray = str_replace('|', ',',  $RD5['Location']);
$LocationArrays = explode(',', $LocationArray);
        $AccurateLocationArray = explode(',', $AccurateLocation);

        $distance = haversineDistance($LocationArrays, $AccurateLocationArray);

        if($distance <= 1){ 
          $in1KM = 'Corresponding';
        }else{
          $in1KM = 'Not Corresponding';
        }
      }else {
           $AccurateLocation = '';
            $distance = '';
      }

      $sheet->setCellValue('A' . $rowNum, $RD5['PStageID']);
      $sheet->setCellValue('B' . $rowNum, $RD5['ReferenceNo']);
      $sheet->setCellValue('C' . $rowNum,  $RD5['StageName']);
      $sheet->setCellValue('D' . $rowNum, $RD5['StageDate']);
      $sheet->setCellValue('E' . $rowNum, $row88['FirstName']. ' '. $row88['LastName']);
      $sheet->setCellValue('F' . $rowNum, $row898['Name']);
      $sheet->setCellValue('G' . $rowNum, $RD5['Location']);
      $sheet->setCellValue('H' . $rowNum, $AccurateLocation);
      $sheet->setCellValue('I' . $rowNum, $distance);
      $sheet->setCellValue('J' . $rowNum, $in1KM);
      $rowNum++;
  } else {
    // Handle the case where no records are found
    $sheet->setCellValue('A2', 'No records found');
}

header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="report.xlsx"');
header('Cache-Control: max-age=0');
header('Cache-Control: max-age=1'); // For IE9

}
$writer = new Xlsx($spreadsheet);
$writer->save('php://output');
exit;
exit;