<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

ob_start('ob_gzhandler');
include('../api/config.php');

require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/Exception.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/PHPMailer.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/SMTP.php';
require '../../inspection.cpvarabia.com/wordlib/vendor/autoload.php';

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$TicketID = $Data->TicketID;
$DegreeID = $Data->DegreeID;
$TransferTo = $Data->TransferTo;
$Attached = $Data->Attached;
$CommentEN = $mysqli->real_escape_string($Data->CommentEN);
$CommentAR = $mysqli->real_escape_string($Data->CommentAR);
$CorrectiveEN = $mysqli->real_escape_string($Data->CorrectiveEN);
$CorrectiveAR = $mysqli->real_escape_string($Data->CorrectiveAR);
$Copy = $Data->Copy;
$TodayIs = date("Y-m-d H:i:s");

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {

    if (empty($TransferTo)) {
        $isTransferTo1 = " ";
        $isTransferTo2 = " ";
    } else {
        $isTransferTo1 = " , `TransferTo` ";
        $isTransferTo2 = " , '$TransferTo' ";
    }
    if (empty($DegreeID)) {
        $isDegreeID1 = " ";
        $isDegreeID2 = " ";
    } else {
        $isDegreeID1 = " , `DegreeID` ";
        $isDegreeID2 = " , '$DegreeID' ";
    }

    if (empty($CommentAR)) {
        $isCommentAR1 = " ";
        $isCommentAR2 = " ";
    } else {
        $isCommentAR1 = " , `CommentAR` ";
        $isCommentAR2 = " , '$CommentAR' ";
    }
    if (empty($CorrectiveEN)) {
        $isCorrectiveEN1 = " ";
        $isCorrectiveEN2 = " ";
    } else {
        $isCorrectiveEN1 = " , `CorrectiveEN` ";
        $isCorrectiveEN2 = " , '$CorrectiveEN' ";
    }
    if (empty($CorrectiveAR)) {
        $isCorrectiveAR1 = " ";
        $isCorrectiveAR2 = " ";
    } else {
        $isCorrectiveAR1 = " , `CorrectiveAR` ";
        $isCorrectiveAR2 = " , '$CorrectiveAR' ";
    }
    if (!empty($Attached)) {
        $filesArray = [];

        foreach ($Attached as $link) {
            $File = basename($link);
            $filesArray[] = $File;
        }
        $FileJson = json_encode($filesArray);

        $File1 = " , `File` ";
        $File2 = " , '$FileJson' ";
    } else {
        $File1 = " ";
        $File2 = " ";
    }

    $res =  $mysqli->query("INSERT INTO `TicketHistory` (`TicketID`, `UpdaterID`, `CommentEN` $isCommentAR1 $isCorrectiveEN1  $isCorrectiveAR1 $isTransferTo1 $isDegreeID1 $File1 , `CreatedAt`) VALUES 
                                                        ('$TicketID', '$PerUserID', '$CommentEN' $isCommentAR2 $isCorrectiveEN2 $isCorrectiveAR2 $isTransferTo2 $isDegreeID2 $File2 , '$TodayIs')");
    if ($res) {
        $resx8r = $mysqli->query("SELECT ProjectID, StageID, UserID,PStageID FROM Ticket WHERE TicketID = '$TicketID'");
        $row8r = mysqli_fetch_array($resx8r);
        $TProjectID = $row8r['ProjectID'];
        $TStageID = $row8r['StageID'];
        $PStageID = $row8r['PStageID'];
        $issuerID = $row8r['UserID'];

        if (!empty($DegreeID)) {

            if ($Copy === "1") {
                $resnts = $mysqli->query("SELECT 
        t.ProjectID, 
        t.PStageID, 
        t.StageID, 
        t.Description, 
        t.TransferTo, 
        p.ReferenceNo
       
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
    t.TicketID = '$TicketID'");
                $resnt = mysqli_fetch_array($resnts);
                if ($resnt['TransferTo'] == 16) {
                    $TicketCode = 'TI600';
                } elseif ($resnt['TransferTo'] == 17) {
                    $TicketCode = 'TI700';
                } elseif ($resnt['TransferTo'] == 18) {
                    $TicketCode = 'TI500';
                } elseif ($resnt['TransferTo'] == 201) {
                    $TicketCode = 'TI900';
                } elseif ($resnt['TransferTo'] == 23) {
                    $TicketCode = 'TI751';
                }

                $res = $mysqli->query("INSERT INTO `Ticket`(`StageID`, `PStageID`, `ProjectID`, `UserID`, `Code`, `Description`, `CreatedAt`) VALUES ('" . $resnt['StageID'] . "','" . $resnt['PStageID'] . "','" . $resnt['ProjectID'] . "', '$PerUserID', '$TicketCode', '" . $resnt['Description'] . "' ,'$TodayIs')");

                if ($res) {
                    $CopyTicketID = $mysqli->insert_id;
                    $mysqli->query("INSERT INTO `TicketHistory` (`TicketID`, `UpdaterID`, `CommentEN`, `TransferTo` , `CreatedAt`) VALUES 
                                                        ('$CopyTicketID', '$PerUserID', '" . $resnt['Description'] . "', '" . $resnt['TransferTo'] . "', '$TodayIs')");

                    $return["TicketID"] = $CopyTicketID;
                    $return["Code"] = $TicketCode;
                    $return["ReferenceNo"] = $resnt['ReferenceNo'];
                    $return["Description"] = $resnt['Description'];
                    $return["Copy"] = 1;
                    $return["TransferTo"] = $resnt['TransferTo'];
                    $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '$PerUserID'");
                    $row967 = mysqli_fetch_array($resx9);
                    $n56722 = mysqli_num_rows($resx9);
                    if ($n55671 != 0) {
                        $return['CreatorName'] = $row8['FirstName'] . " " . $row8['LastName'];
                    }
                    $return["error"] = false;
                } else {
                    $return["error"] = true;
                    $return["message"] = "Error: " . mysqli_error($mysqli);
                }
            } else {
                

   $r34 = $mysqli->query("SELECT `PStageID` FROM `project_stages` WHERE `PStageID` = '$PStageID' AND `Status` = 'Under Review' AND `Deleted` = '0'");
                $r34Co = mysqli_num_rows($r34);
                if ($r34Co > 0) {

                $r34x8r = $mysqli->query("SELECT 
        t.ProjectID
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
    p.`ProjectID` = '$TProjectID' and 
    p.`StageID` = '10' and 
    th.`DegreeID` is NULL and 
    t.`Deleted` = '0'");
                $r34x8rCo = mysqli_num_rows($r34x8r);
                if ($r34x8rCo == 0) {

                    $resx17 = $mysqli->query("SELECT 
    `tickets_degree`.`Name`,
    `t`.`DegreeID`
FROM 
    `Ticket` t
JOIN 
    `tickets_degree` ON `t`.`DegreeID` = `tickets_degree`.`DegreeID`
JOIN 
    `projects` p ON t.ProjectID = p.ProjectID
LEFT JOIN 
    (
        SELECT 
            `TicketHistory`.`TicketID`, 
            MAX(`TicketHistory`.`THID`) AS `MaxTHID`
        FROM 
            `TicketHistory`
        GROUP BY 
            `TicketHistory`.`TicketID`
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    `TicketHistory` th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    p.`ProjectID` = '$TProjectID'
    AND p.`StageID` = '10'
    AND th.`DegreeID` IS NULL
    AND t.`Deleted` = '0'
    AND (
        t.`DegreeID` = '1' OR 
        t.`DegreeID` = '5' OR 
        t.`DegreeID` = '2' OR 
        t.`DegreeID` = '3'
    )
ORDER BY 
    CASE
        WHEN t.`DegreeID` = '1' THEN 1
        WHEN t.`DegreeID` = '5' THEN 2
        WHEN t.`DegreeID` = '2' THEN 3
        WHEN t.`DegreeID` = '3' THEN 4
        ELSE 5
    END
LIMIT 1;
");
                        
                    $row17 = mysqli_fetch_array($resx17);

                    $rsprd1s = $mysqli->query("SELECT 
        t.ProjectID,
        th.`UpdaterID`
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
    p.`ProjectID` = '$TProjectID' and 
    p.`StageID` = '10' and 
    th.`DegreeID` is NULL and 
    th.`TransferTo` = '18' and 
    t.`Deleted` = '0'");
                    $rsprd1 = mysqli_num_rows($rsprd1s);
                    $rsprd11 = mysqli_fetch_array($rsprd1s);
                    if ($rsprd1 > 0) {
                        $rsps = $mysqli->query("SELECT * FROM `SP_reports` WHERE `ProjectID` = '$TProjectID' AND `Type` = 'RD1' AND `Deleted` = '0'");
                        $rsp = mysqli_num_rows($rsps);
                        if ($rsp == 0) {
                            $res = $mysqli->query("INSERT INTO `SP_reports`(`ProjectID`, `UserID`, `Rtype`, `Type`, `CreatedAt`,`Status`,`MaxDegree`, `Deleted`) VALUES ('$TProjectID', '" . $rsprd11['UpdaterID'] . "', 'Simple', 'RD1', '$TodayIs', 'Approved','" . $row17['DegreeID'] . "', '0');");
                        }
                    }
                    $rspdrs = $mysqli->query("SELECT 
        t.ProjectID,
        th.`UpdaterID`
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
    p.`ProjectID` = '$TProjectID' and 
    p.`StageID` = '10' and 
    th.`DegreeID` is NULL and 
    th.`TransferTo` = '16' and 
    t.`Deleted` = '0'");
                    $rspdr = mysqli_num_rows($rspdrs);
                    $rspdr1 = mysqli_fetch_array($rspdrs);
                    if ($rspdr > 0) {
                        $rsps = $mysqli->query("SELECT * FROM `SP_reports` WHERE `ProjectID` = '$TProjectID' AND `Type` = 'dr' AND `Deleted` = '0'");
                        $rsp = mysqli_num_rows($rsps);
                        if ($rsp == 0) {
                            $res = $mysqli->query("INSERT INTO `SP_reports`(`ProjectID`, `UserID`, `Rtype`, `Type`, `CreatedAt`,`Status`,`MaxDegree`, `Deleted`) VALUES ('$TProjectID', '" . $rspdr1['UpdaterID'] . "', 'Simple', 'DR', '$TodayIs', 'Approved','" . $row17['DegreeID'] . "', '0');");
                        }
                    }
                    //----------------------
                     $mysqli->query("UPDATE `project_stages` SET `Status` = 'Manger Approval'  WHERE `PStageID` IN ($PStageID)");
/*
                    // Get the maximum 'Rev' for the given ProjectID
                    $res2 = $mysqli->query("SELECT MAX(`Rev`) as Rev, Status FROM `project_stages` WHERE `ProjectID` = '$TProjectID' and StageID  = '10'");
                    $row2 = mysqli_fetch_array($res2);

                    $Status = $row2['Status'];
                    $rev = (!is_numeric($row2['Rev'])) ? " , `Rev` = '0' " : " , `Rev` = '" . ($row2['Rev'] + 1) . "'";

                    // Retrieve the auto-approval criteria
                    $r66631r = $mysqli->query("SELECT * FROM `autoApprove` WHERE `Type` = '0' and `Active` = '1' and `Deleted` = '0'");
                    while ($row8r = mysqli_fetch_array($r66631r)) {

                        $APID = $row8r['APID'];
                        $AVArea = $row8r['Area'];
                        $AVBasement = $row8r['Basement'];
                        $AVCategory = $row8r['Category'];
                        $AVCost = $row8r['Cost'];
                        $AVHeight = $row8r['Height'];
                        $AVSpecialProject = $row8r['SpecialProject'];
                        $AVUser = $row8r['User'];

                        $notEmptyCount = 0; // Initialize a counter for non-empty variables
                        $ApprovedCount = 0; // Initialize a counter for non-empty variables


                        if (!empty($AVArea)) {
                            $notEmptyCount++;
                        }
                        if (!empty($AVBasement)) {
                            $notEmptyCount++;
                        }
                        if (!empty($AVCategory)) {
                            $notEmptyCount++;
                        }
                        if (!empty($AVCost)) {
                            $notEmptyCount++;
                        }
                        if (!empty($AVHeight)) {
                            $notEmptyCount++;
                        }
                        if (!empty($AVSpecialProject)) {
                            $notEmptyCount++;
                        }
                        if (!empty($AVUser)) {
                            $notEmptyCount++;
                        }
                        $conditions = array();

                        if (!empty($AVCategory)) {
                            $resx8r = $mysqli->query("SELECT `CategoryID` FROM `projects` WHERE `ProjectID`='$TProjectID' AND `CategoryID` not in ($AVCategory) and `Deleted` = '0'");
                            $CategoryID = mysqli_num_rows($resx8r);
                            if ($CategoryID == 0) {
                            } else {
                                $ApprovedCount++;
                            }
                        }

                        if (!empty($AVUser)) {
                            $resx8r = $mysqli->query("SELECT `InspectorID` FROM `project_stages` WHERE `PStageID`= '$PStageID' AND `InspectorID` in ($AVUser) AND `Deleted` ='0'");
                            $InspectorID = mysqli_num_rows($resx8r);
                            if ($InspectorID == 0) {
                            } else {
                                $ApprovedCount++;
                            }
                        }
                        if (!empty($AVSpecialProject)) {
                            $resx8r = $mysqli->query("SELECT * FROM `rd0_answers` WHERE `PStageID` = '$PStageID' AND `OptionID` in ($AVSpecialProject)");
                            $SPP = mysqli_num_rows($resx8r);
                            if ($SPP == 0) {
                            } else {
                                $ApprovedCount++;
                            }
                        }
                        if (!empty($AVCost)) {
                            list($AVCostfrom, $AVCostto) = explode(',', $AVCost);
                            if (empty($AVCostfrom) && empty($AVCostto)) {
                                $IsCost = ' ';
                            } else if (!empty($AVCostfrom) and !empty($AVCostto)) {
                                $IsCost = " and `Cost` between '$AVCostfrom' and '$AVCostto'";
                            } else if (empty($AVCostfrom) and !empty($AVCostto)) {
                                $IsCost = " and `Cost`<= $AVCostto";
                            } else if (!empty($AVCostfrom) and empty($AVCostto)) {
                                $IsCost = " and `Cost`>= $AVCostfrom";
                            }

                            $resx8r = $mysqli->query("SELECT `Cost` FROM `project_costs` WHERE `ProjectID` = '$TProjectID' $IsCost");
                            $Cost = mysqli_num_rows($resx8r);
                            if ($Cost == 0) {
                            } else {
                                $ApprovedCount++;
                            }
                        }

                        if (!empty($AVBasement)) {
                            $resx8r = $mysqli->query("SELECT * FROM `rd0_answers` WHERE `PStageID` = '$PStageID' AND `QID` = 225");
                            $NBas = mysqli_num_rows($resx8r);
                            if ($NBas == 0) {
                            } else {
                                $ApprovedCount++;
                            }
                        }
                        if (!empty($AVHeight)) {
                            list($Heightfrom, $Heightto) = explode(',', $AVHeight);
                            if (empty($Heightfrom) && empty($Heightto)) {
                                $IsHeight = ' ';
                            } else if (!empty($Heightfrom) and !empty($Heightto)) {
                                $IsHeight = " and `Answer` between '$Heightfrom' and '$Heightto'";
                            } else if (empty($Heightfrom) and !empty($Heightto)) {
                                $IsHeight = " and `Answer` <= $Heightto";
                            } else if (!empty($Heightfrom) and empty($Heightto)) {
                                $IsHeight = " and `Answer` >= $Heightfrom";
                            }

                            $resx8r = $mysqli->query("SELECT `Answer` FROM `rd0_answers` where `PStageID` = '$PStageID' and `QID` = '31' $IsHeight");
                            $Heights = mysqli_num_rows($resx8r);
                            if ($Heights == 0) {
                            } else {
                                $ApprovedCount++;
                            }
                        }
                        $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$PStageID' and `QID` = '239'");
                        $Nfloors = 0;
                        while ($row5 = mysqli_fetch_array($res5)) {
                            $Nfloors = $row5['Answer'];
                        }

                        $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$PStageID' and `QID` = '226'");
                        $Nbasement = 0;
                        while ($row5 = mysqli_fetch_array($res5)) {
                            $Nbasement = $row5['Answer'];
                        }

                        $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$PStageID' and `QID` = '243'");
                        $width = 0;
                        while ($row5 = mysqli_fetch_array($res5)) {
                            $width = $row5['Answer'];
                        }

                        $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$PStageID' and `QID` = '242'");
                        $length = 0;
                        while ($row5 = mysqli_fetch_array($res5)) {
                            $length = $row5['Answer'];
                        }
                        if (!empty($AVArea)) {
                            $TArea = ($Nfloors + $Nbasement) * ($width * $length);
                            list($AVAreafrom, $AVAreato) = explode(',', $AVArea);

                            if (empty($AVAreafrom) && empty($AVAreato)) {
                                $AVAreafroms = '';
                                $AVAreatos = '';
                            } else if (!empty($AVAreafrom) and !empty($AVAreato)) {
                                $AVAreafroms = $AVAreafrom;
                                $AVAreatos = $AVAreato;
                            } else if (empty($AVAreafrom) and !empty($AVAreato)) {
                                $AVAreafroms = 0;
                                $AVAreatos = $AVAreato;
                            } else if (!empty($AVAreafrom) and empty($AVAreato)) {
                                $AVAreafroms = $AVAreafrom;
                                $AVAreatos = 999999999999999;
                            }

                            if ($TArea < $AVAreafroms or $TArea > $AVAreatos) {
                            } else {
                                $ApprovedCount++;
                            }
                        }
                        if ($ApprovedCount == $notEmptyCount) {
                            $conditions[] = "`Status` = 'Approved'";
                            break;
                        }
                    }
                    $resx8r = $mysqli->query("SELECT ProjectID, StageID, UserID,PStageID FROM project_tickets WHERE TicketID = '$TicketID'");
                    $row8r = mysqli_fetch_array($resx8r);
                    $TProjectID = $row8r['ProjectID'];
                    $TStageID = $row8r['StageID'];
                    $PStageID = $row8r['PStageID'];
                    if (count($conditions) == 0) {
                        if (!empty($Status) and $Status != 'Out_Of_RDAPP') {
                            $mysqli->query("UPDATE `project_stages` SET `Status` = 'Approved' $rev WHERE `PStageID` IN ($PStageID)");
                        }

                        $mysqli->query("INSERT INTO `autoApprove_History`(`APID`, `UserID`, `PStageID`, `CreatedAt`) VALUES ('$APID','$PerUserID','$PStageID','$TodayIs')");
                    $mysqli->query("INSERT INTO `TicketCorn`(`ProjectID`, `StageID`, `CreatedAt`, `Type`) VALUES ('$TProjectID','$TStageID','$TodayIs', 'Edit')");

                        $r66631r = $mysqli->query("   SELECT 
                        t.TicketID, 
                        t.UserID
                    FROM 
                        Ticket t
                    JOIN 
                        projects p ON t.ProjectID = p.ProjectID 
                    LEFT JOIN 
                        (
                            SELECT 
                                TicketHistory.TicketID, 
                                MAX(TicketHistory.THID) AS MaxTHID
                            FROM 
                                TicketHistory
                            GROUP BY 
                                TicketHistory.TicketID
                        ) th_max ON t.TicketID = th_max.TicketID
                    LEFT JOIN 
                        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
                    WHERE 
                   t.`StageID` = '$TStageID' and t.`ProjectID` = '$TProjectID' and th.`Email` is null");
                                while ($r778r = mysqli_fetch_array($r66631r)) {
                                    $mysqli->query("UPDATE TicketHistory SET Email = '0' WHERE TicketID = '" . $r778r['TicketID'] . "'");
                                }
                    } else {
                        $mysqli->query("UPDATE `project_stages` SET `Status` = 'Manger Approval' WHERE `PStageID` IN ($PStageID)");
                    }
                    */
                    
                    $mail1 = new PHPMailer(true);
                    try {
                        //Server settings
                        //$mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
                        $mail1->isSMTP();                                            //Send using SMTP
                        $mail1->Host       = 'mail.cpvarabia.com';                     //Set the SMTP server to send through
                        $mail1->SMTPAuth   = true;                                   //Enable SMTP authentication
                        $mail1->Username   = 'notify.cpv@cpvarabia.com';                     //SMTP username
                        $mail1->Password   = 'O06$zJ@CrJ4@';                               //SMTP password
                        $mail1->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
                        $mail1->Port       = 465;                                    //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
                        $mail1->CharSet = 'UTF-8';

                        //Recipients
                        $mail1->setFrom('notify.cpv@cpvarabia.com', 'CPV Arabia Tools');

                        $mail1->addAddress($issuermail);
                        $mail1->addCC('design@cpvarabia.com');
                        $mail1->addCC('CS@cpvarabia.com');

                        //Content
                        $mail1->isHTML(true);                                  //Set email format to HTML
                        $mail1->Subject = 'REF # ' . $ReferenceNo . ' RD0 Tickets Completion';
                        $mail1->Body = '';

                        $mail1->Body .= '
                            <p>Dear.<br />
This is an automatic notification to inform you that all tickets of project #REF ' . $ReferenceNo . '  are submitted successfully.<br />
The RD0 file are ready for review.<br />
** RD APP Ticket System **<br /> ';
                        $mail1->send();
                    } catch (Exception $e) {
                        $return["error"] = true;
                        $return["message"] = "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
                    }
                    $return["EmailStatus"] = true;
                } else {
                    $return["EmailStatus"] = false;
                }
            }else{
            
                          $r38r = $mysqli->query("SELECT * FROM `TicketCorn` WHERE `Type` = 'ADD' AND `ProjectID` = '$TProjectID'");
                    $r34o = mysqli_num_rows($r38r);
                    if ($r34o > 0) {
                        if($TProjectID != 0){
                    $mysqli->query("INSERT INTO `TicketCorn`(`ProjectID`, `StageID`, `CreatedAt`, `Type`) VALUES ('$TProjectID','$TStageID','$TodayIs', 'Edit')");
                       $return["ddd"] = 'ffff';
                    }
                    }
                         

                }
            }
        }
        $return["error"] = false;
    } else {
        $return["error"] = true;
        $return["message"] = "Error!";
    }
}

header('Content-Type: application/json');
echo json_encode($return);
