<?php
$servername = "localhost";
$username = "cpvarbia_rd0";
$password = "CCv4XYNkYG9C";
$dbname = "cpvarbia_inspection";

try {
    $pdo = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Receive JSON data from POST
    $jsonInput = file_get_contents("php://input");
    $tickets = json_decode($jsonInput, true);

    foreach ($tickets as $ticket) {
        // Handle file upload if exists
        $filePath = NULL;
        if (isset($_FILES['file']['name']) && $_FILES['file']['error'] == UPLOAD_ERR_OK) {
            $target_dir = "uploads/";
            $target_file = $target_dir . basename($_FILES["file"]["name"]);
            if (move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)) {
                $filePath = $target_file; // Store file path if needed in DB
            }
        }

        // Initialize variables for SQL statement
        $params = [];
        $sql = "";

        // Determine if TicketID is datetime or integer
        if (strtotime($ticket['TicketID']) && !is_numeric($ticket['TicketID'])) {
            // Prepare to insert, exclude TicketID since it's auto-incrementing
            $keys = array_keys($ticket);
            $values = array_values($ticket);
            $insertKeys = [];
            $insertValues = [];

            foreach ($keys as $index => $key) {
                if ($key != 'TicketID' && !empty($values[$index])) { // Exclude TicketID and check for non-empty values
                    $insertKeys[] = $key;
                    $insertValues[] = '?';
                    $params[] = $values[$index];
                }
            }

            $sql = "INSERT INTO project_tickets (" . implode(", ", $insertKeys) . ") VALUES (" . implode(", ", $insertValues) . ")";
        } else {
            // Prepare to update
            $sql = "UPDATE project_tickets SET ";
            $updateSets = [];
            foreach ($ticket as $key => $value) {
                if ($key != 'TicketID' && !empty($value)) { // Exclude TicketID from updates and check for non-empty
                    $updateSets[] = "$key=?";
                    $params[] = $value;
                }
            }
            $sql .= implode(", ", $updateSets) . " WHERE TicketID=?";
            $params[] = $ticket['TicketID'];
        }

        // Prepare and execute SQL statement
        $stmt = $pdo->prepare($sql);
        $stmt->execute($params);
    }

    $return["error"] = false;
} catch(PDOException $e) {
    echo "Error: " . $e->getMessage();
    $return["error"] = true;
}

$pdo = null;

header('Content-Type: application/json');
echo json_encode($return);

