<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

ob_start('ob_gzhandler');
include('../api/config.php');

require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/Exception.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/PHPMailer.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/SMTP.php';
require '../../inspection.cpvarabia.com/wordlib/vendor/autoload.php';


$TodayIs = date("Y-m-d");
$res = $mysqli->query("SELECT `RD6ID`, `ProjectID`
FROM `rd6_reports` WHERE `CreatedAt` < DATE_SUB(NOW(), INTERVAL 9 MONTH) AND `RD3Status` IS NULL ORDER BY `rd6_reports`.`CreatedAt` ASC limit 50");

    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
        while ($row = $res->fetch_assoc()) {
 $ProjectID = $row['ProjectID'];
 $RD6ID = $row['RD6ID'];
$res5 = $mysqli->query("SELECT ReferenceNo, OwnerID, ConstructorID  FROM projects where `ProjectID` = '$ProjectID'");
while ($row5 = $res5->fetch_assoc()) {
    $ReferenceNo = $row5['ReferenceNo'];
   
    $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row5['OwnerID'] . "'");
    $row11 = mysqli_fetch_array($resx11);
    $Owner = $row11['Email'];

    $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row5['ConstructorID'] . "'");
    $row12 = mysqli_fetch_array($resx12);
    $Constructor = $row12['Email'];

    //-----------------
    $mail = new PHPMailer(true);

    try {
        //Server settings
        //$mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
        $mail->isSMTP();                                            //Send using SMTP
        $mail->Host       = 'mail.cpvarabia.com';                     //Set the SMTP server to send through
        $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
        $mail->Username   = 'tis@cpvarabia.com';                     //SMTP username
        $mail->Password   = 'CPV#137948';                               //SMTP password
        $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
        $mail->Port       = 465;                                    //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
        $mail->CharSet = 'UTF-8';

        //Recipients
        $mail->setFrom('tis@cpvarabia.com', 'CPV Arabia RD3');

        if (!empty($Constructor) && !empty($Owner)) {
            $mail->addCC($Constructor);
            $mail->addAddress($Owner);
        } elseif (!empty($Owner) && empty($Constructor)) {
            $mail->addAddress($Owner);
        } elseif (!empty($Constructor) && empty($Owner)) {
            $mail->addAddress($Constructor);
        } else {
        }
        $mail->addCC('IDI@Malath.com.sa');

        $mail->addBCC('notify.cpv@cpvarabia.com');
        $mail->addBCC('tis@cpvarabia.com');


        //Content
        $mail->isHTML(true);                                  //Set email format to HTML
        $mail->Subject = ' تفعيل وثيقه التأمين ضد العيوب الخفيه رقم مرجعي -' . $ReferenceNo;
        $mail->Body = '';

        $mail->Body .= ' 

<body style="text-align:right; direction:rtl;">
عزيزى العميل : <br>
نود تذكيركم بموعد الزياره الأخيره ( تتم بعد تسعة أشهر من تاريخ الزياره النهائيه للمشروع )  الخاصه بفحص العناصر الواقيه لمشروع رقم مرجعي ' . $ReferenceNo . '.<br>

و ذلك لغرض تفعيل وثيقه التأمين ضد العيوب الخفية للعناصر الواقيه من شركه ملاذ للتأمين .<br>
و ستتم هذه الزياره بالتنسيق مع المهندس المختص بأعمال الفحص الفني ، اذا لم يكن لديكم رقم الفاحص الفني المختص  يرجي التواصل معنا علي الرقم التالي  : 920034242<br>
<br>
نشكركم لحسن التعاون المشترك ونتمني ان تنال خدمتنا رضاكم.<br>

</p>

                <p>Dear Sir, <br>

We want to inform you about the upcoming inspection stage of the Waterproofing of envelope assessment with Reference Number # .' . $ReferenceNo . '.<br>
In this inspection stage, scheduled Nine Months after the project`s final visit, waterproofing of envelope assessment is crucial for activating the insurance policy against hidden defects,  <br>
as per Malath Insurance Company`s terms.<br>
Our inspection engineer will coordinate and oversee this process. If you need the contact information for the specialized technical inspector, please call us at 920034242.<br>
<br>
Thank you for your cooperation.<br>
<br>';


        $mail->send();
        $return["error"] = false;
        $mysqli->query("INSERT INTO `RD3_Notify`(`ProjectID`, `Status`, `CreatedAt`) VALUES ('$ProjectID','1','$TodayIs')");
        $mysqli->query("UPDATE `rd6_reports` SET `RD3Date`='$TodayIs',`RD3Status`='1' WHERE `RD6ID`='$RD6ID'");

    } catch (Exception $e) {
        $return["error"] = true;
        $return["message"] = "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
        $mysqli->query("INSERT INTO `RD3_Notify`(`ProjectID`, `Status`, `CreatedAt`) VALUES ('$ProjectID','3','$TodayIs')");
           $mysqli->query("UPDATE `rd6_reports` SET `RD3Date`='$TodayIs',`RD3Status`='3' WHERE `RD6ID`='$RD6ID'");

    }
}

}
}
header('Content-Type: application/json');
echo json_encode($return);
