<?php
ob_start('ob_gzhandler');
include('../../api/config.php');

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$Page = $Data->Page;
$Type = $Data->Type;
$UserID = $Data->UserID;
$ReferenceNo = $Data->ReferenceNo;
$Degree = $Data->Degree;
$CostFrom = $Data->CostFrom;
$CostTo = $Data->CostTo;
$ReportType = $Data->ReportType;
$Cases = $Data->Cases;
$Region = $Data->Region;
$StartDate = $Data->StartDate;
$EndDate = $Data->EndDate;
$AreaFrom = $Data->AreaFrom;
$AreaTo = $Data->AreaTo;
$Lat = $Data->Lat;
$Long = $Data->Long;
$Rad = $Data->Rad;
$isManager = $Data->isManager;
if (!empty($Type) and $Type == 'DR') {
        $TypeID = 14;
        $ResourceType = 16;
} else if (!empty($Type) and $Type == 'RD1') {
        $TypeID = 13;
        $ResourceType = 18;
} else if (!empty($Type) and $Type == 'RD2') {
        $TypeID = 15;
        $ResourceType = 17;
} else {
        $TypeID = 0;
        $ResourceType = 0;
}
$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
        $return["error"] = true;
        $return["message"] = "Access denied!";
} else {

        if (!empty($Type)) {
                $SPMan = $mysqli->query("SELECT Global FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` = '$ResourceType' limit 1");
                $SPMans = mysqli_fetch_array($SPMan);
                //----------------

                $RoleCheckDesMan = $mysqli->query("SELECT Global FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` in (1,3) limit 1");
                $RoleCheckDesMans = mysqli_fetch_array($RoleCheckDesMan);
                //----------------

                if ($SPMans['Global'] == 1) {
                        $return["ISManger"] = true;
                } else if ($RoleCheckDesMans['Global'] == 1) {
                        $return["ISManger"] = true;
                } else {
                        $return["ISManger"] = false;
                }
                $return["error"] = false;

                if (empty($Page)) {
                        $Page = 1;
                } else {
                        $Page = $Data->Page;
                }

                if (empty($ReferenceNo)) {
                        $ReferenceNoa = ' ';
                } else {
                        $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
                }
                if (empty($Degree)) {
                        $MaxDegree = ' ';
                } else {
                        $MaxDegree = " and `SP_reports`.`MaxDegree`  in ($Degree) ";
                }
                if (empty($UserID)) {
                        $Designers = ' ';
                } else {
                        $Designers = " and SP_reports.UserID in ($UserID) ";
                }
                if (empty($ReportType)) {
                        $ReportTypes = ' ';
                } else {
                        $ReportTypes = " and `SP_reports`.`Rtype` = '$ReportType' ";
                }
                if (empty($isManager) or $isManager != true) {
                        $isManagers = " and `SP_reports`.`UserID` = '$PerUserID' ";
                } else {
                        $isManagers = ' ';
                }
                if (empty($Cases)) {
                        $Casess = ' ';
                } else {
                        $Casess = " and `SP_reports`.`Cases` LIKE '%$Cases%' ";
                }
                if (empty($StartDate) && empty($EndDate)) {
                        $IsDate = ' ';
                } else {
                        $IsDate = " and `SP_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
                }
                if (empty($CostFrom) && empty($CostTo)) {
                        $IsCost = ' ';
                } else {
                        $IsCost = " and (`project_costs`.`Cost` between '$CostFrom' and '$CostTo' )";
                }
                if (empty($Region)) {
                        $RegionID = ' ';
                } else {
                        $RegionID = " and `project_locations`.`Region` in ($Region) ";
                }
                if (empty($AreaFrom) && empty($AreaTo)) {
                        $IsArea = ' ';
                } else {
                        $IsArea = " and (`SP_reports`.`Area` between $AreaFrom and $AreaTo )";
                }
                //------------
               
                if(!empty($Lat) and !empty($Long)){
                $resx88 = $mysqli->query("SELECT `project_locations`.`AccurateLocation`, `SP_reports`.`ProjectID` FROM `project_locations`, `SP_reports` WHERE `project_locations`.`ProjectID` = `SP_reports`.`ProjectID` and `SP_reports`.`Type` = '$Type' and `project_locations`.`AccurateLocation` is NOT NULL");
                $numrows1 = mysqli_num_rows($resx88);
                if ($numrows1 > 0) {
                        $projectIDs = array();

                        while ($row88 = $resx88->fetch_assoc()) {
                                $AccurateLocation = $row88['AccurateLocation'];
                                $url = "https://rd0.cpvarabia.com/maps/NearestSP.php?L=$AccurateLocation&C=$Lat,$Long";
                                $ch = curl_init();
                                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                                curl_setopt($ch, CURLOPT_URL, $url);
                                $result = curl_exec($ch);
                                curl_close($ch);
                                $Q = json_decode($result);

                                if ($Q->distance < $Rad) {
                                        $projectIDs[] = $row88['ProjectID'];
                                }
                        }

                        if (!empty($projectIDs)) {
                                $Pls = implode(',', $projectIDs);
                                $projectIDList = " and SP_reports.ProjectID in ($Pls) ";
                        } else {
                                $projectIDList = '';
                        }
                }
        }

                $query = "SELECT COUNT(`SP_reports`.`SPID`) as num from `SP_reports`, `projects`, `project_costs`, `project_locations` 
                where SP_reports.ProjectID = projects.ProjectID and SP_reports.ProjectID = projects.ProjectID and SP_reports.ProjectID = project_costs.ProjectID and SP_reports.ProjectID = project_locations.ProjectID 
                $ReferenceNoa $MaxDegree $Designers $ReportTypes $Casess $IsDate $IsCost $RegionID $IsArea $projectIDList $isManagers
                and SP_reports.Deleted = '0' and `SP_reports`.`Type` = '$Type' order by SP_reports.SPID DESC";
                $total_pages = mysqli_fetch_array($mysqli->query($query));
                $total_pages = $total_pages['num'];

                $limit = 25;
                if ($Page) {
                        $start = ($Page - 1) * $limit;
                } else {
                        $start = 0;
                }

                $res = $mysqli->query("SELECT `SP_reports`.* ,`projects`.`ReferenceNo`, `projects`.`ConstructorID`, `projects`.`DesignerOfficeID`, `projects`.`Soil` From `SP_reports`, `projects`, `project_costs`, `project_locations` 
                where SP_reports.ProjectID = projects.ProjectID and SP_reports.ProjectID = projects.ProjectID and SP_reports.ProjectID = project_costs.ProjectID and SP_reports.ProjectID = project_locations.ProjectID 
                $ReferenceNoa $MaxDegree $Designers $ReportTypes $Casess $IsDate $IsCost $RegionID $IsArea $projectIDList $isManagers
                and SP_reports.Deleted = '0' and `SP_reports`.`Type` = '$Type' order by SP_reports.SPID DESC LIMIT $start, $limit");
                if ($res === false) {
                        die("Query failed: " . $mysqli->error);
                }
                if ($res) {
                        while ($row = $res->fetch_assoc()) {
                                $return[$row['SPID']]['SPID'] = $row['SPID'];
                                $return[$row['SPID']]['ProjectID'] = $row['ProjectID'];
                                $return[$row['SPID']]['UserID'] = $row['UserID'];
                                $return[$row['SPID']]['Rtype'] = $row['Rtype'];
                                $return[$row['SPID']]['CreatedAt'] = $row['CreatedAt'];
                                $return[$row['SPID']]['Cases'] = $row['Cases'];
                                $return[$row['SPID']]['Status'] = $row['Status'];

                                $resx10 = $mysqli->query("SELECT * FROM `users` where `UserID` = '" . $row['UserID'] . "'");
                                $row10 = mysqli_fetch_array($resx10);
                                $return[$row['SPID']]['UserName'] = $row10['FirstName'] . " " . $row10['LastName'];
                                $return[$row['SPID']]['ReferenceNo'] = $row['ReferenceNo'];
                                $return[$row['SPID']]['ConstructorID'] = $row['ConstructorID'];
                                $return[$row['SPID']]['DesignerOfficeID'] = $row['DesignerOfficeID'];
                                $res855 = $mysqli->query("SELECT `NameAr` FROM `SOIL_Companies` WHERE `ID` = '".$row['Soil']."'");
                                $row855 = mysqli_fetch_array($res855);
                                $return[$row['SPID']]['Soil'] = $row855['NameAr'];
                                $resx11 = $mysqli->query("SELECT * FROM `project_users` where `PUID` = '" . $row['DesignerOfficeID'] . "'");
                                $row11 = mysqli_fetch_array($resx11);
                                $return[$row['SPID']]['DesignerOfficeName'] = $row11['Name'];
                                $resx12 = $mysqli->query("SELECT * FROM `project_users` where `PUID` = '" . $row['ConstructorID'] . "'");
                                $row12 = mysqli_fetch_array($resx12);
                                $return[$row['SPID']]['ConstructorName'] = $row12['Name'];

                                $resx16 = $mysqli->query("SELECT Rev,PStageID,Status,InspectorID FROM `project_stages` WHERE `ProjectID` = '" . $row['ProjectID'] . "' and `StageID` = '$TypeID' and `Deleted` = '0' ORDER BY `StageDate` DESC LIMIT 1");
                                $numrows100 = mysqli_num_rows($resx16);
                                if ($numrows100 > 0) {
                                        $row16 = mysqli_fetch_array($resx16);
                                        $return[$row['SPID']]['Rev'] = $row16['Rev'];
                                        $return[$row['SPID']]['PStageID'] = $row16['PStageID'];
                                        $return[$row['SPID']]['RejectedReason'] = $row16['RejectedReason'];
                                }
                                $return[$row['SPID']]['DegreeID'] = $row['MaxDegree'];

                                $resx17 = $mysqli->query("SELECT `Name` FROM `tickets_degree` WHERE `DegreeID` ='" . $row['MaxDegree'] . "'");
                                $row17 = mysqli_fetch_array($resx17);
                                $return[$row['SPID']]['MaxDegree'] = $row17['Name'];
                        }

                        $lastpage = ceil($total_pages / $limit);
                        $return["TotalItems"] = $total_pages;
                        $return["TotalPages"] = $lastpage;
                        $return["Page"] = $Page;
                } else {
                        $return["error"] = true;
                }
        } else {
                $return["error"] = true;
                $return["message"] = "Type Empty!";
        }
}

header('Content-Type: application/json');
echo json_encode($return);
