<?php

ob_start('ob_gzhandler');
include('../api/config.php');

$TodayIs = date("Y-m-d H:i:s");
$Last120Min = date('Y-m-d H:i:s', strtotime('-15 minutes'));
$mysqli->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

$Project = $mysqli->query("SELECT `ProjectID` , `StageID` FROM `TicketCorn` WHERE `Status` = '0' and `CreatedAt` <= '$Last120Min' limit 10 FOR UPDATE");
while ($Projects = mysqli_fetch_array($Project)) {
    if (count($Projects) > 0) {
        $ProjectID = $Projects['ProjectID'];
        $StageID = $Projects['StageID'];

        $resx10 = $mysqli->query("SELECT `InspectorID` FROM `project_stages` WHERE `ProjectID` = '$ProjectID' AND `StageID` = '$StageID' AND `Deleted` = '0' 
ORDER BY `project_stages`.`PStageID` DESC LIMIT 1");
        $row10 = mysqli_fetch_array($resx10);
        $issuerID = $row10['InspectorID'];

        $res5 = $mysqli->query("SELECT * FROM `Special_Projects` WHERE `ProjectID` = '$ProjectID'");
        $row5 = $res5->fetch_assoc();
        $Precast = $row5['Precast'];
        $Steel = $row5['Steel'];

        $res5 = $mysqli->query("SELECT `Special` FROM `projects` WHERE `ProjectID`= '$ProjectID'");
        $row5 = $res5->fetch_assoc();
        $Special = $row5['Special'];

        $res5 = $mysqli->query("SELECT OwnerID as OID, ConstructorID as CID, ReferenceNo, Token FROM projects WHERE ProjectID = '$ProjectID' AND Deleted = '0'");
        $row5 = $res5->fetch_assoc();
        $ReferenceNo = $row5['ReferenceNo'];
        $Token = $row5['Token'];

        $resx10 = $mysqli->query("SELECT `Email` FROM `users` WHERE `UserID` = '$issuerID'");
        $row10 = mysqli_fetch_array($resx10);
        $Usermail = $row10['Email'];

        $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` WHERE `PUID` = '" . $row5['OID'] . "'");
        $row11 = mysqli_fetch_array($resx11);
        $OE = $row11['Email'];
        $OwnerName = $row11['Name'];
        $OMobile = 966 . substr($row11['Mobile'], -9);

        $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` WHERE `PUID` = '" . $row5['CID'] . "'");
        $row12 = mysqli_fetch_array($resx12);
        $CE = $row12['Email'];
        $CMobile = 966 . substr($row12['Mobile'], -9);


        // SMS API data
        $data = [
            'userName' => $smsuserName,
            'numbers' => $OMobile,
            $CMobile,
            'userSender' => $smsuserSender,
            'apiKey' => $smsapiKey,
            'msg' => 'عزيزنا العميل، تجدون الملاحظات الفنية لمشروعكم ' . $ReferenceNo . ' عبر الرابط (tickets.cpvarabia.com/?Tr=' . $Token . ')'
        ];

        // Send SMS using cURL
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $smsapiUrl);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $smsResponse = curl_exec($ch);
        curl_close($ch);

        // Send WhatsApp message using multi-template API
        $url = 'https://wp.designal.cc/api/v1/chats/' . $CMobile . '/messages/multi-templates';
        $data = array(
            "templateName" => "notes_rd0",
            "ref" => $ReferenceNo,
            "link" => 'tickets.cpvarabia.com/?Tr=' . $Token
        );

        $headers = array(
            'Content-Type: application/json',
            'Authorization: Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6IjY1Yjk2OTE2NjBjYTJiYzU5NmYxZGI0MyIsImlhdCI6MTcyNTIyNDgyNn0.a3DM0N69rYzLnKCbW12BxQUPnAwyhrfm8UeGFB5IWN0'
        );

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        $whatsAppResponse = curl_exec($ch);
        curl_close($ch);


       // Prepare the email content
$tickContentEN = '';
$tickContentAR = '';

// Content storage for each degree type
$degree1ContentAR = '';
$degree1ContentEN = '';
$degree5ContentAR = '';
$degree5ContentEN = '';
$degree2_3ContentAR = '';
$degree2_3ContentEN = '';

// Query to generate ticket content
$DS2 = $mysqli->query("
    SELECT th.`CommentEN`, th.`CorrectiveEN`, th.`CommentAR`, th.`CorrectiveAR`, th.`DegreeID`
    FROM Ticket t
    JOIN projects p ON t.ProjectID = p.ProjectID
    LEFT JOIN (
        SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID
        FROM TicketHistory
        GROUP BY TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE t.StageID = '$StageID' AND t.ProjectID = '$ProjectID' AND th.DegreeID IN (1,2,3,5)
");

if (mysqli_num_rows($DS2) > 0) {
    while ($D2 = mysqli_fetch_array($DS2)) {
        if ($D2['DegreeID'] == 1) {
            // Append content to degree 1 without repeating the title
            if (empty($degree1ContentAR)) {
                $degree1ContentAR .= "<p><b># مخاطر خاصة بالتصميم قد تهدد سلامة المبنى</b> (يتم حلها بإرسال سيادتكم للمستندات المطلوبة قبل زيارة المهندس الفاحص الفني إلى الموقع):</p><ol>";
                $degree1ContentEN .= "<p><b># Design observations may affect the building stability</b> (to be resolved by your side by sending the required documents before the technical site inspection visit):</p><ol>";
            }
            $degree1ContentAR .= "<li>{$D2['CommentAR']}</li>";
            $degree1ContentEN .= "<li>{$D2['CommentEN']}</li>";
            if (!empty($D2['CorrectiveAR'])) {
                $degree1ContentAR .= "- {$D2['CorrectiveAR']}";
                $degree1ContentEN .= "- {$D2['CorrectiveEN']}";
            }
        } elseif ($D2['DegreeID'] == 5) {
            // Append content to degree 5 without repeating the title
            if (empty($degree5ContentAR)) {
                $degree5ContentAR .= "<p><b># مخاطر خاصة بمرحلة التنفيذ</b> (يتم إغلاقها مع سيادتكم في الموقع أثناء زيارة المهندس الفاحص الفني إلى الموقع):</p><ol>";
                $degree5ContentEN .= "<p><b># Execution stage observations</b> (to be closed with you on-site during the technical site inspection visit):</p><ol>";
            }
            $degree5ContentAR .= "<li>{$D2['CommentAR']}</li>";
           
            if (!empty($D2['CorrectiveAR'])) {
                $degree5ContentAR .= "- {$D2['CorrectiveAR']}";
               
            }
        } elseif ($D2['DegreeID'] == 2 || $D2['DegreeID'] == 3) {
            // Append content to degrees 2 and 3 without repeating the title
            if (empty($degree2_3ContentAR)) {
                $degree2_3ContentAR .= "<p><b># تحفظات فنية وملاحظات:</b></p><ol>";
                $degree2_3ContentEN .= "<p><b># Technical Reservations and Notes:</b></p><ol>";
            }
            $degree2_3ContentAR .= "<li>{$D2['CommentAR']}</li>";
            $degree2_3ContentEN .= "<li>{$D2['CommentEN']}</li>";
            if (!empty($D2['CorrectiveAR'])) {
                $degree2_3ContentAR .= "- {$D2['CorrectiveAR']}";
                $degree2_3ContentEN .= "- {$D2['CorrectiveEN']}";
            }
        }

        // Check if there are files to be mentioned
        if (!empty($D2['File'])) {
            $tickContentAR .= "<br>- يرجى الاطلاع على المرفقات.";
            $tickContentEN .= "<br>- Check the attachments.";
        }
    }

    // Close ordered lists for each degree type
    if (!empty($degree1ContentAR)) {
        $degree1ContentAR .= "</ol>";
        $degree1ContentEN .= "</ol>";
    }
    if (!empty($degree5ContentAR)) {
        $degree5ContentAR .= "</ol>";
        $degree5ContentEN .= "</ol>";
    }
    if (!empty($degree2_3ContentAR)) {
        $degree2_3ContentAR .= "</ol>";
        $degree2_3ContentEN .= "</ol>";
    }

    // Concatenate all degree content together
    $tickContentAR .= "<div dir='rtl'>" . $degree1ContentAR . $degree5ContentAR . $degree2_3ContentAR . "</div>";
    $tickContentEN .= "<div>" . $degree1ContentEN . $degree5ContentEN . $degree2_3ContentEN . "</div>";
}

// Add the attachment link
$tickContentEN .= '# To view attachments, follow the link: <a href="https://tickets.cpvarabia.com/?Tr=' . $Token . '">Click here</a>';
$tickContentAR .= '<div dir="rtl"> # للاطلاع على المرفقات، اتبع الرابط: <a href="https://tickets.cpvarabia.com/?Tr=' . $Token . '">اضغط هنا</a></div>';

// Set up variables for MailerSend
$variablesArray = [
    ['var' => 'REF', 'value' => $ReferenceNo],
    ['var' => 'TICKEN', 'value' => $tickContentEN],
    ['var' => 'TICKAR', 'value' => $tickContentAR]
];


        // Prepare the recipients
        $recipients = [];
        if (!empty($CE)) {
            $recipients[] = ['email' => $CE, 'name' => 'Constructor']; // Replace with real name
        }
        if (!empty($OE)) {
            $recipients[] = ['email' => $OE, 'name' => $OwnerName];
        }

        // Prepare the cc recipients
        $cc_recipients = [
            ['email' => 'design@cpvarabia.com'],
            ['email' => 'CS@cpvarabia.com'],
            ['email' => 'notify.cpv@cpvarabia.com'],
            ['email' => 'IDI@Malath.com.sa']
        ];

        if (!empty($Usermail)) {
            $cc_recipients[] = ['email' => $Usermail];
        }
        // Prepare the attachments
        $attachmentsArray = [];

        if ($Special == 1 && $Steel == '2') {
            $attachmentsArray[] = [
                'content' => base64_encode(file_get_contents("https://rd0.cpvarabia.com/uploads/SteelStructureProjectsContractorGuidelinesAR.pdf")),
                'filename' => "Ar Steel Structure Contractor Guidelines",
                'disposition' => 'attachment'
            ];
            $attachmentsArray[] = [
                'content' => base64_encode(file_get_contents("https://rd0.cpvarabia.com/uploads/SteelStructureProjectsContractorGuidelinesEN.pdf")),
                'filename' => "EN Steel Structure Contractor Guidelines",
                'disposition' => 'attachment'
            ];
        } else if ($Special == 1 && $Precast == '2') {
            $attachmentsArray[] = [
                'content' => base64_encode(file_get_contents("https://rd0.cpvarabia.com/uploads/PrecastProjectsContractorGuidelinesAR.pdf")),
                'filename' => "Ar Precast Contractor Guidelines",
                'disposition' => 'attachment'
            ];
            $attachmentsArray[] = [
                'content' => base64_encode(file_get_contents("https://rd0.cpvarabia.com/uploads/PrecastProjectsContractorGuidelinesEN.pdf")),
                'filename' => "EN Precast Contractor Guidelines",
                'disposition' => 'attachment'
            ];
        } else if ($Special == 0) {
            $attachmentsArray[] = [
                'content' => base64_encode(file_get_contents("https://rd0.cpvarabia.com/uploads/ContractorGuidelinesAR.pdf")),
                'filename' => "Ar Contractor Guidelines",
                'disposition' => 'attachment'
            ];
            $attachmentsArray[] = [
                'content' => base64_encode(file_get_contents("https://rd0.cpvarabia.com/uploads/ContractorGuidelinesEN.pdf")),
                'filename' => "EN Contractor Guidelines",
                'disposition' => 'attachment'
            ];
        }
        $curl = curl_init();

        $payload = json_encode([
            'from' => [
                'email' => 'tis@cpvarabia.com',
                'name' => 'CPVARABIA TIS'
            ],
            'to' => $recipients,
            'cc' => $cc_recipients,
            'bcc' => [
                [
                    'email' => 'tis@cpvarabia.com',
                    'name' => 'CPVARABIA TIS'
                ]
            ],
            'subject' => 'TIS # ' . $ReferenceNo . ' Report updates:',
            'variables' => [['email' => $CE, 'substitutions' => $variablesArray]],
            'template_id' => 'z3m5jgrvreo4dpyo', // Replace with your actual template ID
            'attachments' => $attachmentsArray // Add attachments here
        ]);

        curl_setopt_array($curl, [
            CURLOPT_URL => "https://api.mailersend.com/v1/email",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $payload,
            CURLOPT_HTTPHEADER => [
                "Content-Type: application/json",
                "X-Requested-With: XMLHttpRequest",
                "Authorization: Bearer mlsn.940e543a908aeb15f1194cee1da9366914fba97f418348d3a31ffa56ecf92749"
            ],
        ]);

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
             $return["cURLError"] = "cURL Error #:" . $err;
            $mysqli->query("UPDATE `TicketCorn` SET `Status`='2' WHERE `ProjectID` = '$ProjectID' and `Status`='0'");
             $mysqli->commit();
        } else {
            $return["response"] = $response;
            $mysqli->query("UPDATE `TicketCorn` SET `Status`='1' WHERE `ProjectID` = '$ProjectID' and `Status`='0'");
             $mysqli->commit();
        }
    } else {
        $return["EmailStatus"] = false;
    }
    $mysqli->commit();

}

header('Content-Type: application/json');
echo json_encode($return);
