<?php
ob_start('ob_gzhandler');
include('../api/config.php');

     $res = $mysqli->query("
    SELECT 
        t.TicketID, 
        t.PStageID,
        t.ProjectID, 
        t.TransferTo as TT,
        t.StageID, 
        t.Description, 
        t.UserID, 
        t.Code, 
        t.CreatedAt, 
        p.OwnerID as OID, 
        p.ConstructorID as CID,
        p.ReferenceNo,
        th.`THID`,th.`CommentEN`,th.`CommentAR`,th.`CorrectiveEN`,th.`CorrectiveAR`,th.`TransferTo`,th.`UpdaterID`,th.`DegreeID`,th.`File`
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
                 Where  TicketHistory.DegreeID is not null or TicketHistory.TransferTo is not null
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
       t.`CreatedAt` BETWEEN '2024-10-21 00:00:00.000000' AND '2024-10-31 23:59:59.000000'
       
    ORDER BY 
        t.TicketID DESC 
    
");

   
    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
        while ($row = $res->fetch_assoc()) {
            
            if(is_numeric($row['TransferTo'])){
                $TransferTo = $row['TransferTo'];
            }else{
                $TransferTo = $row['TT'];
            }
            $return[$row['TicketID']]['TicketID'] = $row['TicketID'];
            $return[$row['TicketID']]['StageID'] = $row['StageID'];
            $return[$row['TicketID']]['TransferTo'] = $TransferTo;
            $resx8r = $mysqli->query("SELECT StageName, Category FROM `stages` where `StageID` = '" . $row['StageID'] . "'");
            $row8r = mysqli_fetch_array($resx8r);
            $return[$row['TicketID']]['StageName'] = $row8r['StageName'];
            $return[$row['TicketID']]['StageCategory'] = $row8r['Category'];
            $return[$row['TicketID']]['ProjectID'] = $row['ProjectID'];
            $return[$row['TicketID']]['CreatorID'] = $row['UserID'];
            $return[$row['TicketID']]['Code'] = $row['Code'];
            $return[$row['TicketID']]['DegreeID'] = $row['DegreeID'];
            $resx10 = $mysqli->query("SELECT StageDate FROM `project_stages` WHERE `PStageID` = '" . $row['PStageID'] . "'");
            $row10 = mysqli_fetch_array($resx10);
            $return[$row['TicketID']]['RD0Date'] = $row10['StageDate'];
            $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
            $row11 = mysqli_fetch_array($resx11);
            $return[$row['TicketID']]['OwnerMobile'] = $row11['Mobile'];
            $return[$row['TicketID']]['OwnerEmail'] = $row11['Email'];
            $return[$row['TicketID']]['OwnerName'] = $row11['Name'];
            $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
            $row12 = mysqli_fetch_array($resx12);
            $return[$row['TicketID']]['ConstructorMobile'] = $row12['Mobile'];
            $return[$row['TicketID']]['ConstructorEmail'] = $row12['Email'];
            $return[$row['TicketID']]['ConstructorName'] = $row12['Name'];
            $resx81r = $mysqli->query("SELECT Name, Category FROM `tickets_degree` where `DegreeID` = '" . $row['DegreeID'] . "'");
            $row81r = mysqli_fetch_array($resx81r);
            $return[$row['TicketID']]['DegreeName'] = $row81r['Name'];
            $return[$row['TicketID']]['DegreeCategory'] = $row81r['Category'];
            $resx88r = $mysqli->query("SELECT Name FROM `role_resources` where `ResourceID` = '$TransferTo'");
            $row88r = mysqli_fetch_array($resx88r);
            $return[$row['TicketID']]['TransferToName'] = $row88r['Name'];
            $return[$row['TicketID']]['Description'] = $row['CommentEN'];
            $return[$row['TicketID']]['CommentEN'] = $row['CommentEN'];
            $return[$row['TicketID']]['CommentAR'] = $row['CommentAR'];
            $return[$row['TicketID']]['CorrectiveEN'] = $row['CorrectiveEN'];
            $return[$row['TicketID']]['CorrectiveAR'] = $row['CorrectiveAR'];
            $return[$row['TicketID']]['CreatedAt'] = $row['CreatedAt'];
           

            $resx81r220 = $mysqli->query("SELECT `Token` FROM `rd5_reports` WHERE `TicketID` = '" . $row['TicketID'] . "'");
            $row81r220 = mysqli_fetch_array($resx81r220);
            $return[$row['TicketID']]['RD5Token'] = $row81r220['Token'];
            $r888244 = $mysqli->query("SELECT ReportID, Status FROM `rd5_reports` where `TicketID` = '" . $row['TicketID'] . "' limit 1");
            $r99ow84 = mysqli_fetch_array($r888244);
            $return[$row['TicketID']]['RD5ReportID'] = $r99ow84['ReportID'];
            $return[$row['TicketID']]['ReferenceNo'] = $row['ReferenceNo'];
            $resx821 = $mysqli->query("SELECT TicketID FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "' and `CreatedAt` BETWEEN '2024-10-21 00:00:00.000000' AND '2024-10-31 23:59:59.000000'");
            $n53321 = mysqli_num_rows($resx821);
            $resx8244 = $mysqli->query("SELECT DegreeID FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "' and `DegreeID` is not NULL and `CreatedAt` BETWEEN '2024-10-21 00:00:00.000000' AND '2024-10-31 23:59:59.000000'");
            $row84 = mysqli_fetch_array($resx8244);
            if ($n53321 > 1) {
                $isEdited = false;
            } else {
                $isEdited = true;
            }
            if ($row84['DegreeID']) {
                $isDegreeEdited = true;
            } else {
                $isDegreeEdited = false;
            }
            $return[$row['TicketID']]['TicketEditedCounter'] = $n53321;
            $return[$row['TicketID']]['TicketEdited'] = $isEdited;
            $return[$row['TicketID']]['DegreeEdited'] = $isDegreeEdited;
            
              $resx81r990 = $mysqli->query("SELECT DegreeID,UpdaterID FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "' and `DegreeID` is not NULL and `CreatedAt` BETWEEN '2024-10-21 00:00:00' AND '2024-10-31 23:59:59' ");
            $i = 0;
            while ($rowx81r990 = $resx81r990->fetch_assoc()) {
                $resx81r = $mysqli->query("SELECT Name FROM `tickets_degree` where `DegreeID` = '" . $rowx81r990['DegreeID'] . "'");
            $row81r = mysqli_fetch_array($resx81r);
                $return[$row['TicketID']]['HisDegree'.$i] = $row81r['Name'];
                $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $rowx81r990['UpdaterID'] . "'");
                $row967 = mysqli_fetch_array($resx9);
                $return[$row['TicketID']]['HisUpdaterName'.$i] = $row967['FirstName'] . " " . $row967['LastName'];
                $i++;
            }
            $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['UserID'] . "'");
            $row8 = mysqli_fetch_array($resx8);
            $n55671 = mysqli_num_rows($resx8);
            $resx955 = $mysqli->query("SELECT UpdaterID , CreatedAt FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "' and `CreatedAt` != '".$row['CreatedAt']."'  and `CreatedAt` BETWEEN '2024-10-21 00:00:00.000000' AND '2024-10-31 23:59:59.000000' order by THID desc limit 1");
            $ro5967 = mysqli_fetch_array($resx955);

            $return[$row['TicketID']]['LastUpdate'] = $ro5967['CreatedAt'];
            //and (`Type` is null or `Type` != '2')
            $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
            $row967 = mysqli_fetch_array($resx9);
            $n56722 = mysqli_num_rows($resx9);
            if ($n55671 != 0) {
                $return[$row['TicketID']]['CreatorName'] = $row8['FirstName'] . " " . $row8['LastName'];
            }
            if ($n56722 != 0) {
                $return[$row['TicketID']]['UpdaterName'] = $row967['FirstName'] . " " . $row967['LastName'];
            } else {
                $return[$row['TicketID']]['UpdaterName'] = NULL;
            }
        }
    
    } else {
        $return["error"] = true;
        $return["message"] = "Not Found!";
    }

$filePath = __DIR__ . '/output.json';
$result = file_put_contents($filePath, json_encode($return, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE));

if ($result === false) {
    echo "Failed to write to $filePath";
} else {
    echo "File saved successfully to $filePath";
}
