<?php
ob_start('ob_gzhandler');
include('../../api/config.php');

$Pos = json_decode(file_get_contents('php://input'));
$PerToken = trim($Pos->PerToken);
$PerUserID = trim($Pos->PerUserID);
$PerRoleID = trim($Pos->PerRoleID);
$Page = $Pos->Page;
$ReportID = $Pos->ReportID;
$ReferenceNo = $Pos->ReferenceNo;
$Category = $Pos->Category;
$RD6Status = $Pos->RD6Status;
$Designer = $Pos->Designer;
$Inspector = $Pos->Inspector;
$InsReviewer = $Pos->InsReviewer;
$CostFrom = $Pos->CostFrom;
$CostTo = $Pos->CostTo;
$StartDate = $Pos->StartDate;
$EndDate = $Pos->EndDate;
$ReportShow = $Pos->ReportShow;
$InProgress = $Pos->InProgress;
$RD3StartDate = $Pos->RD3StartDate;
$RD3EndDate = $Pos->RD3EndDate;
$RD3Status = $Pos->RD3Status;



if (strpos($InProgress, '1') !== false) {
  $InProgress1 = " AND rd6_reports.RD6ID NOT in (SELECT `RD6ID` FROM `rd6_history` where `Action` = '5') ";
} else {
  $InProgress1 = " ";
}
if (strpos($InProgress, '2') !== false) {
  $InProgress2 = " and `rd6_reports`.`des_status` = 'InProgress' AND rd6_reports.RD6ID in (SELECT `RD6ID` FROM `rd6_history` where `Action` = '5') ";
} else {
  $InProgress2 = " ";
}
if (strpos($InProgress, '3') !== false) {
  $InProgress3 = " AND rd6_reports.RD6ID NOT in (SELECT `RD6ID` FROM `rd6_history` where `Action` = '1') ";
} else {
  $InProgress3 = " ";
}
if (strpos($InProgress, '4') !== false) {
  $InProgress4 = " and `rd6_reports`.`ins_status` = 'InProgress' AND rd6_reports.RD6ID in (SELECT `RD6ID` FROM `rd6_history` where `Action` = '1') ";
} else {
  $InProgress4 = " ";
}
if (strpos($InProgress, '5') !== false) {
  $InProgress5 = " and `rd6_reports`.`insrev_status` = 'InProgress'  and (`rd6_reports`.`ins_status` = 'Approved' and `rd6_reports`.`des_status` = 'Approved' )";
} else {
  $InProgress5 = " ";
}

$RoleCheckInsMan = $mysqli->query("SELECT Global FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` in (2,4) limit 1");
$RoleCheckInsMans = mysqli_fetch_array($RoleCheckInsMan);
//----------------
$RoleCheckInsEng = $mysqli->query("SELECT Permissions FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` = '4' limit 1");
$RoleCheckInsEngs = mysqli_fetch_array($RoleCheckInsEng);
//----------------
$RoleCheckDesEng = $mysqli->query("SELECT Permissions FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` = '3' limit 1");
$RoleCheckDesEngs = mysqli_fetch_array($RoleCheckDesEng);
//----------------
$RoleCheckDesMan = $mysqli->query("SELECT Global FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` in (1,3) limit 1");
$RoleCheckDesMans = mysqli_fetch_array($RoleCheckDesMan);
//----------------
$RoleCheckInsRev = $mysqli->query("SELECT Global FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` = '20' limit 1");
$RoleCheckInsRevs = mysqli_fetch_array($RoleCheckInsRev);
//----------------
$RoleCheckQC = $mysqli->query("SELECT Permissions FROM `roles` WHERE `ParentID` = '$PerRoleID' and `Deleted` = '0' and `ResourceID` = '22' limit 1");
$RoleCheckQCs = mysqli_fetch_array($RoleCheckQC);
//----------------
if ($RoleCheckInsMans['Global'] == 1) {

  if (empty($Page)) {
    $Page = 1;
  } else {
    $Page = $Pos->Page;
  }
  if (empty($ReportID)) {
    $ReportIDs = ' ';
  } else {
    $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
  }
  if (empty($ReferenceNo)) {
    $ReferenceNoa = ' ';
  } else {
    $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
  }
  if (empty($Category)) {
    $CategoryID = ' ';
  } else {
    $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
  }
  if (empty($ReportShow)) {
    $ReportShows = ' ';
  } else {
    $ReportShows = " and `rd6_reports`.`Status` = 'InProgress' ";
  }
  if (empty($RD6Status)) {
    $Statusa = ' ';
  } else {
    $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
    $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
  }
  if (empty($RD3Status)) {
    $RD3Statusa = ' ';
  } else {
    $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
    $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
  }
  if (empty($Designer)) {
    $Designers = ' ';
  } else {
    $Designers = " and rd6_reports.DesUserID in ($Designer) ";
  }
  if (empty($Inspector)) {
    $Inspectors = ' ';
  } else {
    $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
  }
  if (empty($CostFrom) && empty($CostTo)) {
    $IsCost = ' ';
  } else {
    $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
  }
  if (empty($StartDate) && empty($EndDate)) {
    $IsDate = ' ';
  } else {
    $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
  }
  if (empty($RD3StartDate) && empty($RD3EndDate)) {
    $IsRD3Date = ' ';
  } else {
    $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
  }
  $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID AND projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows $CategoryID $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date order by rd6_reports.`RD6ID` DESC";
  $total_pages = mysqli_fetch_array($mysqli->query($query));
  $total_pages = $total_pages['num'];

  $limit = 25;
  if ($Page) {
    $start = ($Page - 1) * $limit;
  } else {
    $start = 0;
  }

  $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and  projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
  $numrows = mysqli_num_rows($res);
  if ($numrows > 0) {
    while ($row = $res->fetch_assoc()) {
      $dt = new DateTime($row['CreatedAt']);
      $DATE = $dt->format('d-m-Y');
      $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
      $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
      $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
      $return[$row['RD6ID']]['StageID'] = $row['FVID'];
      $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];

      $link = 'http://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD6_' . $row['PStageID'] . '.docx';

      if (@file_get_contents($link)) {
        $return[$row['RD6ID']]['Link'] = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD6_' . $row['PStageID'] . '.docx';
      } else {
        $return[$row['RD6ID']]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd6.php?PStageID=' . $row['PStageID'];
      }

      $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
      $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
      $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
      $return[$row['RD6ID']]['Status'] = $row['Status'];
      if ($row['RD3Status'] != 1) {
        $return[$row['RD6ID']]['RD3Status'] = 2;
        $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
      } else {
        $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
        $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
      }

      $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
      $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
      $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
      $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
      $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];
      $return[$row['RD6ID']]['CreatedAt'] = $DATE;

      $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
      if (mysqli_num_rows($res144) == 0) {
        $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
      } else {
        $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
        $row88 = mysqli_fetch_array($resx88);
        if ($row88['Status'] == 1 or $row88['Status'] == 2) {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
        } else {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
        }
      }

      $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");
      $numrows11 = mysqli_num_rows($res122);
      $return[$row['RD6ID']]["TicketNum"] = $numrows11;
      $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
      $row88 = mysqli_fetch_array($resx88);
      $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
      $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
      $row910 = mysqli_fetch_array($res910);
      if ($row910['Type'] == 0) {
        $return[$row['RD6ID']]['SubContractor'] = False;
      } else if ($row910['Type'] == 1) {
        $return[$row['RD6ID']]['SubContractor'] = True;
      }
      $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
      $numrows1 = mysqli_num_rows($res11);
      if ($numrows1 > 0) {
        $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
        $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
      } else {
        $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
        $row99 = mysqli_fetch_array($res99);
        $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
        $row89 = mysqli_fetch_array($resx89);
        $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
        $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
      }

      $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
      $row8 = mysqli_fetch_array($resx8);
      $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

      $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
      $row11 = mysqli_fetch_array($resx11);
      $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
      $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
      $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
      $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
      $row12 = mysqli_fetch_array($resx12);
      $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
      $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
      $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

      $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
      $row16 = mysqli_fetch_array($resx16);
      $return[$row['RD6ID']]['Category'] = $row16['Name'];

      $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
      $row10 = mysqli_fetch_array($resx10);
      $return[$row['RD6ID']]['Cost'] = $row10['Cost'];

      $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
      $row1 = mysqli_num_rows($res1);

      if ($row1 != 0) {
        $return[$row['RD6ID']]['InsReport'] = true;
      } else {
        $return[$row['RD6ID']]['InsReport'] = false;
      }

      $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
      $row3 = mysqli_num_rows($res3);

      if ($row3 != 0) {
        $return[$row['RD6ID']]['DesReport'] = true;
      } else {
        $return[$row['RD6ID']]['DesReport'] = false;
      }

      $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
      $row81r009 = mysqli_fetch_array($resx81r990);
      $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

      $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
      $row9 = mysqli_fetch_array($res9);
      $return[$row['RD6ID']]['Description'] = $row9['Description'];

      $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
      $ro5967 = mysqli_fetch_array($resx955);
      $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
      $row967 = mysqli_fetch_array($resx9);
      $n56722 = mysqli_num_rows($resx9);

      if ($n56722 != 0) {
        $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
      } else {
        $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
      }
    }
    $lastpage = ceil($total_pages / $limit);
    $return["TotalItems"] = $total_pages;
    $return["TotalPages"] = $lastpage;
    $return["Page"] = $Page;
    $return["error"] = false;
  } else {
    $return["error"] = true;
    $return["message"] = "Not Found!";
  }
} else if ($RoleCheckInsRevs['Global'] == 1) {


  if (empty($Page)) {
    $Page = 1;
  } else {
    $Page = $Pos->Page;
  }
  if (empty($ReportID)) {
    $ReportIDs = ' ';
  } else {
    $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
  }
  if (empty($ReferenceNo)) {
    $ReferenceNoa = ' ';
  } else {
    $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
  }
  if (empty($Category)) {
    $CategoryID = ' ';
  } else {
    $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
  }
  if (empty($ReportShow)) {
    $ReportShows = ' ';
  } else {
    $ReportShows = " and `rd6_reports`.`insrev_status` = 'InProgress' ";
  }
  if (empty($RD6Status)) {
    $Statusa = ' ';
  } else {
    $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
    $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
  }
  if (empty($RD3Status)) {
    $RD3Statusa = ' ';
  } else {
    $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
    $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
  }
  if (empty($Designer)) {
    $Designers = ' ';
  } else {
    $Designers = " and rd6_reports.DesUserID in ($Designer) ";
  }
  if (empty($Inspector)) {
    $Inspectors = ' ';
  } else {
    $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
  }
  if (empty($CostFrom) && empty($CostTo)) {
    $IsCost = ' ';
  } else {
    $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
  }
  if (empty($StartDate) && empty($EndDate)) {
    $IsDate = ' ';
  } else {
    $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
  }
  if (empty($RD3StartDate) && empty($RD3EndDate)) {
    $IsRD3Date = ' ';
  } else {
    $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
  }
  $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID AND projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date order by rd6_reports.`RD6ID` DESC";
  $total_pages = mysqli_fetch_array($mysqli->query($query));
  $total_pages = $total_pages['num'];

  $limit = 25;
  if ($Page) {
    $start = ($Page - 1) * $limit;
  } else {
    $start = 0;
  }

  $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and  projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
  $numrows = mysqli_num_rows($res);
  if ($numrows > 0) {
    while ($row = $res->fetch_assoc()) {
      $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
      $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
      $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
      $return[$row['RD6ID']]['StageID'] = $row['FVID'];
      $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
      $link = 'http://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD6_' . $row['PStageID'] . '.docx';

      if (@file_get_contents($link)) {
        $return[$row['RD6ID']]['Link'] = 'https://inspection.cpvarabia.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD6_' . $row['PStageID'] . '.docx';
      } else {
        $return[$row['RD6ID']]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd6.php?PStageID=' . $row['PStageID'];
      }
      $dt = new DateTime($row['CreatedAt']);
      $DATE = $dt->format('d-m-Y');
      $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
      $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
      $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
      $return[$row['RD6ID']]['Status'] = $row['insrev_status'];
      if ($row['RD3Status'] != 1) {
        $return[$row['RD6ID']]['RD3Status'] = 2;
        $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
      } else {
        $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
        $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
      }

      $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
      $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
      $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
      $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
      $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

      $return[$row['RD6ID']]['CreatedAt'] = $DATE;
      $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
      if (mysqli_num_rows($res144) == 0) {
        $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
      } else {
        $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
        $row88 = mysqli_fetch_array($resx88);
        if ($row88['Status'] == 1 or $row88['Status'] == 2) {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
        } else {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
        }
      }
      $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");      $numrows11 = mysqli_num_rows($res122);
      $return[$row['RD6ID']]["TicketNum"] = $numrows11;
      $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
      $row88 = mysqli_fetch_array($resx88);
      $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
      $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
      $row910 = mysqli_fetch_array($res910);
      if ($row910['Type'] == 0) {
        $return[$row['RD6ID']]['SubContractor'] = False;
      } else if ($row910['Type'] == 1) {
        $return[$row['RD6ID']]['SubContractor'] = True;
      }
      $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
      $numrows1 = mysqli_num_rows($res11);
      if ($numrows1 > 0) {
        $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
        $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
      } else {
        $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
        $row99 = mysqli_fetch_array($res99);
        $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
        $row89 = mysqli_fetch_array($resx89);
        $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
        $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
      }

      $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
      $row8 = mysqli_fetch_array($resx8);
      $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

      $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
      $row11 = mysqli_fetch_array($resx11);
      $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
      $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
      $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
      $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
      $row12 = mysqli_fetch_array($resx12);
      $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
      $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
      $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

      $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
      $row16 = mysqli_fetch_array($resx16);
      $return[$row['RD6ID']]['Category'] = $row16['Name'];

      $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
      $row10 = mysqli_fetch_array($resx10);
      $return[$row['RD6ID']]['Cost'] = $row10['Cost'];

      $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
      $row1 = mysqli_num_rows($res1);

      if ($row1 != 0) {
        $return[$row['RD6ID']]['InsReport'] = true;
      } else {
        $return[$row['RD6ID']]['InsReport'] = false;
      }

      $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
      $row3 = mysqli_num_rows($res3);

      if ($row3 != 0) {
        $return[$row['RD6ID']]['DesReport'] = true;
      } else {
        $return[$row['RD6ID']]['DesReport'] = false;
      }

      $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
      $row81r009 = mysqli_fetch_array($resx81r990);
      $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

      $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
      $row9 = mysqli_fetch_array($res9);
      $return[$row['RD6ID']]['Description'] = $row9['Description'];

      $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
      $ro5967 = mysqli_fetch_array($resx955);
      $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
      $row967 = mysqli_fetch_array($resx9);
      $n56722 = mysqli_num_rows($resx9);

      if ($n56722 != 0) {
        $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
      } else {
        $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
      }
    }
    $lastpage = ceil($total_pages / $limit);
    $return["TotalItems"] = $total_pages;
    $return["TotalPages"] = $lastpage;
    $return["Page"] = $Page;
    $return["error"] = false;
  } else {
    $return["error"] = true;
    $return["message"] = "Not Found!";
  }
} else if ($RoleCheckDesMans['Global'] == 1) {


  if (empty($Page)) {
    $Page = 1;
  } else {
    $Page = $Pos->Page;
  }
  if (empty($ReportID)) {
    $ReportIDs = ' ';
  } else {
    $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
  }
  if (empty($ReferenceNo)) {
    $ReferenceNoa = ' ';
  } else {
    $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
  }
  if (empty($Category)) {
    $CategoryID = ' ';
  } else {
    $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
  }
  if (empty($ReportShow)) {
    $ReportShows = ' ';
  } else {
    $ReportShows = " and `rd6_reports`.`des_status` = 'InProgress' ";
  }
  if (empty($RD6Status)) {
    $Statusa = ' ';
  } else {
    $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
    $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
  }
  if (empty($RD3Status)) {
    $RD3Statusa = ' ';
  } else {
    $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
    $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
  }
  if (empty($Designer)) {
    $Designers = ' ';
  } else {
    $Designers = " and rd6_reports.DesUserID in ($Designer) ";
  }
  if (empty($Inspector)) {
    $Inspectors = ' ';
  } else {
    $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
  }
  if (empty($CostFrom) && empty($CostTo)) {
    $IsCost = ' ';
  } else {
    $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
  }
  if (empty($StartDate) && empty($EndDate)) {
    $IsDate = ' ';
  } else {
    $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
  }
  if (empty($RD3StartDate) && empty($RD3EndDate)) {
    $IsRD3Date = ' ';
  } else {
    $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
  }
  $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID AND projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date order by rd6_reports.`RD6ID` DESC";
  $total_pages = mysqli_fetch_array($mysqli->query($query));
  $total_pages = $total_pages['num'];

  $limit = 25;
  if ($Page) {
    $start = ($Page - 1) * $limit;
  } else {
    $start = 0;
  }

  $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and  projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
  $numrows = mysqli_num_rows($res);
  if ($numrows > 0) {
    while ($row = $res->fetch_assoc()) {
      $dt = new DateTime($row['CreatedAt']);
      $DATE = $dt->format('d-m-Y');
      $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
      $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
      $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
      $return[$row['RD6ID']]['StageID'] = $row['FVID'];
      $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
      $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
      $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
      $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
      $return[$row['RD6ID']]['Status'] = $row['des_status'];
      if ($row['RD3Status'] != 1) {
        $return[$row['RD6ID']]['RD3Status'] = 2;
        $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
      } else {
        $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
        $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
      }

      $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
      $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
      $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
      $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
      $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

      $return[$row['RD6ID']]['CreatedAt'] = $DATE;
      $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
      if (mysqli_num_rows($res144) == 0) {
        $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
      } else {
        $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
        $row88 = mysqli_fetch_array($resx88);
        if ($row88['Status'] == 1 or $row88['Status'] == 2) {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
        } else {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
        }
      }
      $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");      $numrows11 = mysqli_num_rows($res122);
      $return[$row['RD6ID']]["TicketNum"] = $numrows11;
      $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
      $row88 = mysqli_fetch_array($resx88);
      $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
      $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
      $row910 = mysqli_fetch_array($res910);
      if ($row910['Type'] == 0) {
        $return[$row['RD6ID']]['SubContractor'] = False;
      } else if ($row910['Type'] == 1) {
        $return[$row['RD6ID']]['SubContractor'] = True;
      }
      $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
      $numrows1 = mysqli_num_rows($res11);
      if ($numrows1 > 0) {
        $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
        $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
      } else {
        $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
        $row99 = mysqli_fetch_array($res99);
        $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
        $row89 = mysqli_fetch_array($resx89);
        $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
        $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
      }

      $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
      $row8 = mysqli_fetch_array($resx8);
      $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

      $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
      $row11 = mysqli_fetch_array($resx11);
      $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
      $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
      $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
      $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
      $row12 = mysqli_fetch_array($resx12);
      $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
      $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
      $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

      $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
      $row16 = mysqli_fetch_array($resx16);
      $return[$row['RD6ID']]['Category'] = $row16['Name'];

      $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
      $row10 = mysqli_fetch_array($resx10);
      $return[$row['RD6ID']]['Cost'] = $row10['Cost'];
      $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
      $row1 = mysqli_num_rows($res1);

      if ($row1 != 0) {
        $return[$row['RD6ID']]['InsReport'] = true;
      } else {
        $return[$row['RD6ID']]['InsReport'] = false;
      }

      $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
      $row3 = mysqli_num_rows($res3);

      if ($row3 != 0) {
        if ($row910['Type'] == 1 && $row['QC_status'] == "Approved") {
          $return[$row['RD6ID']]['DesReport'] = true;
        } else if ($row910['Type'] == 1 && $row['QC_status'] != "Approved") {
          $return[$row['RD6ID']]['DesReport'] = "hhhh";
        } else {
          $return[$row['RD6ID']]['DesReport'] = true;
        }
      } else {
        $return[$row['RD6ID']]['DesReport'] = false;
      }

      $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
      $row81r009 = mysqli_fetch_array($resx81r990);
      $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

      $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
      $row9 = mysqli_fetch_array($res9);
      $return[$row['RD6ID']]['Description'] = $row9['Description'];

      $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
      $ro5967 = mysqli_fetch_array($resx955);
      $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
      $row967 = mysqli_fetch_array($resx9);
      $n56722 = mysqli_num_rows($resx9);

      if ($n56722 != 0) {
        $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
      } else {
        $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
      }
    }
    $lastpage = ceil($total_pages / $limit);
    $return["TotalItems"] = $total_pages;
    $return["TotalPages"] = $lastpage;
    $return["Page"] = $Page;
    $return["error"] = false;
  } else {
    $return["error"] = true;
    $return["message"] = "Not Found!";
  }
} else if (($RoleCheckInsEngs['Permissions'] == 1) || ($RoleCheckInsEngs['Permissions'] == 2) || ($RoleCheckInsEngs['Permissions'] == 3) || ($RoleCheckInsEngs['Permissions'] == 4)) {

  $CheckSupervisor = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='$PerUserID' and Deleted = '0' ");
  $CheckSupervisors = mysqli_fetch_array($CheckSupervisor);
  $CheckSupervisornum = mysqli_num_rows($CheckSupervisor);

  //----------------
  if ($CheckSupervisornum > 0) {
    if (empty($Page)) {
      $Page = 1;
    } else {
      $Page = $Pos->Page;
    }
    if (empty($ReportID)) {
      $ReportIDs = ' ';
    } else {
      $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
    }
    if (empty($ReferenceNo)) {
      $ReferenceNoa = ' ';
    } else {
      $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
    }
    if (empty($Category)) {
      $CategoryID = ' ';
    } else {
      $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
    }
    if (empty($ReportShow)) {
      $ReportShows = ' ';
    } else {
      $ReportShows = " and `rd6_reports`.`ins_status` = 'InProgress' ";
    }
    if (empty($RD6Status)) {
      $Statusa = ' ';
    } else {
      $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
      $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
    }
    if (empty($RD3Status)) {
      $RD3Statusa = ' ';
    } else {
      $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
      $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
    }
    if (empty($Designer)) {
      $Designers = ' ';
    } else {
      $Designers = " and rd6_reports.DesUserID in ($Designer) ";
    }
    if (empty($Inspector)) {
      $Inspectors = ' ';
    } else {
      $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
    }
    if (empty($CostFrom) && empty($CostTo)) {
      $IsCost = ' ';
    } else {
      $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
    }
    if (empty($StartDate) && empty($EndDate)) {
      $IsDate = ' ';
    } else {
      $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
    }
    if (empty($RD3StartDate) && empty($RD3EndDate)) {
      $IsRD3Date = ' ';
    } else {
      $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
    }
    $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND (`rd6_reports`.`InsUserID` in(SELECT `UserID` FROM `user_chart` WHERE `OCID` = '" . $CheckSupervisors['OCID'] . "') or `rd6_reports`.`InsUserID` = '$PerUserID' ) order by rd6_reports.`RD6ID` DESC";
    $total_pages = mysqli_fetch_array($mysqli->query($query));
    $total_pages = $total_pages['num'];

    $limit = 25;
    if ($Page) {
      $start = ($Page - 1) * $limit;
    } else {
      $start = 0;
    }

    $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND (`rd6_reports`.`InsUserID` in(SELECT `UserID` FROM `user_chart` WHERE `OCID` = '" . $CheckSupervisors['OCID'] . "') or `rd6_reports`.`InsUserID` = '$PerUserID' ) order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
      while ($row = $res->fetch_assoc()) {
        $dt = new DateTime($row['CreatedAt']);
        $DATE = $dt->format('d-m-Y');
        $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
        $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
        $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
        $return[$row['RD6ID']]['StageID'] = $row['FVID'];
        $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
        $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
        $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
        $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
        $return[$row['RD6ID']]['Status'] = $row['ins_status'];
        if ($row['RD3Status'] != 1) {
          $return[$row['RD6ID']]['RD3Status'] = 2;
          $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
        } else {
          $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
          $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
        }

        $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
        $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
        $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
        $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
        $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

        $return[$row['RD6ID']]['CreatedAt'] = $DATE;
        $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
        if (mysqli_num_rows($res144) == 0) {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
        } else {
          $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
          $row88 = mysqli_fetch_array($resx88);
          if ($row88['Status'] == 1 or $row88['Status'] == 2) {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
          } else {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
          }
        }
        $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");        $numrows11 = mysqli_num_rows($res122);
        $return[$row['RD6ID']]["TicketNum"] = $numrows11;
        $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
        $row88 = mysqli_fetch_array($resx88);
        $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
        $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
        $row910 = mysqli_fetch_array($res910);
        if ($row910['Type'] == 0) {
          $return[$row['RD6ID']]['SubContractor'] = False;
        } else if ($row910['Type'] == 1) {
          $return[$row['RD6ID']]['SubContractor'] = True;
        }
        $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
        $numrows1 = mysqli_num_rows($res11);
        if ($numrows1 > 0) {
          $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
          $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
        } else {
          $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
          $row99 = mysqli_fetch_array($res99);
          $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
          $row89 = mysqli_fetch_array($resx89);
          $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
          $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
        }

        $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
        $row8 = mysqli_fetch_array($resx8);
        $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

        $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
        $row11 = mysqli_fetch_array($resx11);
        $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
        $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
        $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
        $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
        $row12 = mysqli_fetch_array($resx12);
        $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
        $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
        $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

        $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
        $row16 = mysqli_fetch_array($resx16);
        $return[$row['RD6ID']]['Category'] = $row16['Name'];

        $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
        $row10 = mysqli_fetch_array($resx10);
        $return[$row['RD6ID']]['Cost'] = $row10['Cost'];

        $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
        $row1 = mysqli_num_rows($res1);

        if ($row1 != 0) {
          $return[$row['RD6ID']]['InsReport'] = true;
        } else {
          $return[$row['RD6ID']]['InsReport'] = false;
        }

        $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
        $row3 = mysqli_num_rows($res3);

        if ($row3 != 0) {
          $return[$row['RD6ID']]['DesReport'] = true;
        } else {
          $return[$row['RD6ID']]['DesReport'] = false;
        }

        $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
        $row81r009 = mysqli_fetch_array($resx81r990);
        $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

        $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
        $row9 = mysqli_fetch_array($res9);
        $return[$row['RD6ID']]['Description'] = $row9['Description'];

        $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
        $ro5967 = mysqli_fetch_array($resx955);
        $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
        $row967 = mysqli_fetch_array($resx9);
        $n56722 = mysqli_num_rows($resx9);

        if ($n56722 != 0) {
          $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
        } else {
          $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
        }
      }
      $lastpage = ceil($total_pages / $limit);
      $return["TotalItems"] = $total_pages;
      $return["TotalPages"] = $lastpage;
      $return["Page"] = $Page;
      $return["error"] = false;
    } else {
      $return["error"] = true;
      $return["message"] = "Not Found!";
    }
  } else {

    if (empty($Page)) {
      $Page = 1;
    } else {
      $Page = $Pos->Page;
    }
    if (empty($ReportID)) {
      $ReportIDs = ' ';
    } else {
      $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
    }
    if (empty($ReferenceNo)) {
      $ReferenceNoa = ' ';
    } else {
      $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
    }
    if (empty($Category)) {
      $CategoryID = ' ';
    } else {
      $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
    }
    if (empty($ReportShow)) {
      $ReportShows = ' ';
    } else {
      $ReportShows = " and `rd6_reports`.`ins_status` = 'InProgress' ";
    }
    if (empty($RD6Status)) {
      $Statusa = ' ';
    } else {
      $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
      $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
    }
    if (empty($RD3Status)) {
      $RD3Statusa = ' ';
    } else {
      $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
      $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
    }
    if (empty($Designer)) {
      $Designers = ' ';
    } else {
      $Designers = " and rd6_reports.DesUserID in ($Designer) ";
    }
    if (empty($Inspector)) {
      $Inspectors = ' ';
    } else {
      $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
    }
    if (empty($CostFrom) && empty($CostTo)) {
      $IsCost = ' ';
    } else {
      $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
    }
    if (empty($StartDate) && empty($EndDate)) {
      $IsDate = ' ';
    } else {
      $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
    }
    if (empty($RD3StartDate) && empty($RD3EndDate)) {
      $IsRD3Date = ' ';
    } else {
      $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
    }
    $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND `rd6_reports`.`InsUserID` = '$PerUserID' order by rd6_reports.`RD6ID` DESC";
    $total_pages = mysqli_fetch_array($mysqli->query($query));
    $total_pages = $total_pages['num'];

    $limit = 25;
    if ($Page) {
      $start = ($Page - 1) * $limit;
    } else {
      $start = 0;
    }

    $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND `rd6_reports`.`InsUserID` = '$PerUserID' order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
      while ($row = $res->fetch_assoc()) {
        $dt = new DateTime($row['CreatedAt']);
        $DATE = $dt->format('d-m-Y');
        $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
        $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
        $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
        $return[$row['RD6ID']]['StageID'] = $row['FVID'];
        $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
        $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
        $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
        $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
        $return[$row['RD6ID']]['Status'] = $row['ins_status'];
        if ($row['RD3Status'] != 1) {
          $return[$row['RD6ID']]['RD3Status'] = 2;
          $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
        } else {
          $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
          $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
        }

        $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
        $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
        $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
        $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
        $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

        $return[$row['RD6ID']]['CreatedAt'] = $DATE;
        $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
        if (mysqli_num_rows($res144) == 0) {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
        } else {
          $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
          $row88 = mysqli_fetch_array($resx88);
          if ($row88['Status'] == 1 or $row88['Status'] == 2) {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
          } else {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
          }
        }
        $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");        $numrows11 = mysqli_num_rows($res122);
        $return[$row['RD6ID']]["TicketNum"] = $numrows11;
        $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
        $row88 = mysqli_fetch_array($resx88);
        $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
        $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
        $row910 = mysqli_fetch_array($res910);
        if ($row910['Type'] == 0) {
          $return[$row['RD6ID']]['SubContractor'] = False;
        } else if ($row910['Type'] == 1) {
          $return[$row['RD6ID']]['SubContractor'] = True;
        }
        $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
        $numrows1 = mysqli_num_rows($res11);
        if ($numrows1 > 0) {
          $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
          $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
        } else {
          $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
          $row99 = mysqli_fetch_array($res99);
          $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
          $row89 = mysqli_fetch_array($resx89);
          $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
          $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
        }

        $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
        $row8 = mysqli_fetch_array($resx8);
        $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

        $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
        $row11 = mysqli_fetch_array($resx11);
        $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
        $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
        $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
        $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
        $row12 = mysqli_fetch_array($resx12);
        $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
        $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
        $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

        $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
        $row16 = mysqli_fetch_array($resx16);
        $return[$row['RD6ID']]['Category'] = $row16['Name'];

        $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
        $row10 = mysqli_fetch_array($resx10);
        $return[$row['RD6ID']]['Cost'] = $row10['Cost'];
        $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
        $row1 = mysqli_num_rows($res1);

        if ($row1 != 0) {
          $return[$row['RD6ID']]['InsReport'] = true;
        } else {
          $return[$row['RD6ID']]['InsReport'] = false;
        }

        $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
        $row3 = mysqli_num_rows($res3);

        if ($row3 != 0) {
          $return[$row['RD6ID']]['DesReport'] = true;
        } else {
          $return[$row['RD6ID']]['DesReport'] = false;
        }
        $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
        $row81r009 = mysqli_fetch_array($resx81r990);
        $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

        $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
        $row9 = mysqli_fetch_array($res9);
        $return[$row['RD6ID']]['Description'] = $row9['Description'];

        $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
        $ro5967 = mysqli_fetch_array($resx955);
        $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
        $row967 = mysqli_fetch_array($resx9);
        $n56722 = mysqli_num_rows($resx9);

        if ($n56722 != 0) {
          $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
        } else {
          $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
        }
      }
      $lastpage = ceil($total_pages / $limit);
      $return["TotalItems"] = $total_pages;
      $return["TotalPages"] = $lastpage;
      $return["Page"] = $Page;
      $return["error"] = false;
    } else {
      $return["error"] = true;
      $return["message"] = "Not Found!";
    }
  }
} else if (($RoleCheckDesEngs['Permissions'] == 1) || ($RoleCheckDesEngs['Permissions'] == 2) || ($RoleCheckDesEngs['Permissions'] == 3) || ($RoleCheckDesEngs['Permissions'] == 4)) {


  if (($RoleCheckQCs['Permissions'] == 1) || ($RoleCheckQCs['Permissions'] == 2) || ($RoleCheckQCs['Permissions'] == 3) || ($RoleCheckQCs['Permissions'] == 4)) {


    $CheckQC = $mysqli->query("SELECT `OCID` FROM `user_chart` WHERE `UserID` = '$PerUserID'");
    $CheckQCs = mysqli_fetch_array($CheckQC);
    $CheckQCnum = mysqli_num_rows($CheckQC);

    //----------------
    if ($CheckQCnum > 0) {
      if (empty($Page)) {
        $Page = 1;
      } else {
        $Page = $Pos->Page;
      }
      if (empty($ReportID)) {
        $ReportIDs = ' ';
      } else {
        $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
      }
      if (empty($ReferenceNo)) {
        $ReferenceNoa = ' ';
      } else {
        $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
      }
      if (empty($Category)) {
        $CategoryID = ' ';
      } else {
        $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
      }
      if (empty($ReportShow)) {
        $ReportShows = ' ';
      } else {
        $ReportShows = " and `rd6_reports`.`QC_status` = 'InProgress' ";
      }
      if (empty($RD6Status)) {
        $Statusa = ' ';
      } else {
        $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
        $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
      }
      if (empty($RD3Status)) {
        $RD3Statusa = ' ';
      } else {
        $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
        $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
      }
      if (empty($Designer)) {
        $Designers = ' ';
      } else {
        $Designers = " and rd6_reports.DesUserID in ($Designer) ";
      }
      if (empty($Inspector)) {
        $Inspectors = ' ';
      } else {
        $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
      }
      if (empty($CostFrom) && empty($CostTo)) {
        $IsCost = ' ';
      } else {
        $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
      }
      if (empty($StartDate) && empty($EndDate)) {
        $IsDate = ' ';
      } else {
        $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
      }
      if (empty($RD3StartDate) && empty($RD3EndDate)) {
        $IsRD3Date = ' ';
      } else {
        $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
      }
      $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND (`rd6_reports`.`DesUserID` in(SELECT `UserID` FROM `user_chart` WHERE `OCID` = '" . $CheckQCs['OCID'] . "') or `rd6_reports`.`DesUserID` = '$PerUserID' ) order by rd6_reports.`RD6ID` DESC";
      $total_pages = mysqli_fetch_array($mysqli->query($query));
      $total_pages = $total_pages['num'];

      $limit = 25;
      if ($Page) {
        $start = ($Page - 1) * $limit;
      } else {
        $start = 0;
      }

      $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND (`rd6_reports`.`DesUserID` in(SELECT `UserID` FROM `user_chart` WHERE `OCID` = '" . $CheckQCs['OCID'] . "') or `rd6_reports`.`DesUserID` = '$PerUserID' ) order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
      $numrows = mysqli_num_rows($res);
      if ($numrows > 0) {
        while ($row = $res->fetch_assoc()) {
          $dt = new DateTime($row['CreatedAt']);
          $DATE = $dt->format('d-m-Y');
          $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
          $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
          $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
          $return[$row['RD6ID']]['StageID'] = $row['FVID'];
          $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
          $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
          $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
          $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
          $return[$row['RD6ID']]['Status'] = $row['des_status'];
          if ($row['RD3Status'] != 1) {
            $return[$row['RD6ID']]['RD3Status'] = 2;
            $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
          } else {
            $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
            $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
          }

          $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
          $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
          $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
          $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
          $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

          $return[$row['RD6ID']]['CreatedAt'] = $DATE;
          $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
          if (mysqli_num_rows($res144) == 0) {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
          } else {
            $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
            $row88 = mysqli_fetch_array($resx88);
            if ($row88['Status'] == 1 or $row88['Status'] == 2) {
              $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
            } else {
              $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
            }
          }
          $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");          $numrows11 = mysqli_num_rows($res122);
          $return[$row['RD6ID']]["TicketNum"] = $numrows11;
          $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
          $row88 = mysqli_fetch_array($resx88);
          $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
          $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
          $row910 = mysqli_fetch_array($res910);
          if ($row910['Type'] == 0) {
            $return[$row['RD6ID']]['SubContractor'] = False;
          } else if ($row910['Type'] == 1) {
            $return[$row['RD6ID']]['SubContractor'] = True;
          }
          $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
          $numrows1 = mysqli_num_rows($res11);
          if ($numrows1 > 0) {
            $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
            $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
          } else {
            $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
            $row99 = mysqli_fetch_array($res99);
            $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
            $row89 = mysqli_fetch_array($resx89);
            $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
            $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
          }

          $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
          $row8 = mysqli_fetch_array($resx8);
          $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

          $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
          $row11 = mysqli_fetch_array($resx11);
          $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
          $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
          $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
          $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
          $row12 = mysqli_fetch_array($resx12);
          $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
          $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
          $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

          $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
          $row16 = mysqli_fetch_array($resx16);
          $return[$row['RD6ID']]['Category'] = $row16['Name'];

          $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
          $row10 = mysqli_fetch_array($resx10);
          $return[$row['RD6ID']]['Cost'] = $row10['Cost'];

          $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
          $row1 = mysqli_num_rows($res1);

          if ($row1 != 0) {
            $return[$row['RD6ID']]['InsReport'] = true;
          } else {
            $return[$row['RD6ID']]['InsReport'] = false;
          }

          $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
          $row3 = mysqli_num_rows($res3);

          if ($row3 != 0) {
            $return[$row['RD6ID']]['DesReport'] = true;
          } else {
            $return[$row['RD6ID']]['DesReport'] = false;
          }

          $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
          $row81r009 = mysqli_fetch_array($resx81r990);
          $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

          $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
          $row9 = mysqli_fetch_array($res9);
          $return[$row['RD6ID']]['Description'] = $row9['Description'];

          $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
          $ro5967 = mysqli_fetch_array($resx955);
          $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
          $row967 = mysqli_fetch_array($resx9);
          $n56722 = mysqli_num_rows($resx9);

          if ($n56722 != 0) {
            $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
          } else {
            $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
          }
        }
        $lastpage = ceil($total_pages / $limit);
        $return["TotalItems"] = $total_pages;
        $return["TotalPages"] = $lastpage;
        $return["Page"] = $Page;
        $return["error"] = false;
      } else {
        $return["error"] = true;
        $return["message"] = "Not Found!";
      }
    } else {

      if (empty($Page)) {
        $Page = 1;
      } else {
        $Page = $Pos->Page;
      }
      if (empty($ReportID)) {
        $ReportIDs = ' ';
      } else {
        $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
      }
      if (empty($ReferenceNo)) {
        $ReferenceNoa = ' ';
      } else {
        $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
      }
      if (empty($Category)) {
        $CategoryID = ' ';
      } else {
        $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
      }
      if (empty($ReportShow)) {
        $ReportShows = ' ';
      } else {
        $ReportShows = " and `rd6_reports`.`des_status` = 'InProgress' ";
      }
      if (empty($RD6Status)) {
        $Statusa = ' ';
      } else {
        $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
        $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
      }
      if (empty($RD3Status)) {
        $RD3Statusa = ' ';
      } else {
        $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
        $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
      }
      if (empty($Designer)) {
        $Designers = ' ';
      } else {
        $Designers = " and rd6_reports.DesUserID in ($Designer) ";
      }
      if (empty($Inspector)) {
        $Inspectors = ' ';
      } else {
        $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
      }
      if (empty($CostFrom) && empty($CostTo)) {
        $IsCost = ' ';
      } else {
        $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
      }
      if (empty($StartDate) && empty($EndDate)) {
        $IsDate = ' ';
      } else {
        $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
      }
      if (empty($RD3StartDate) && empty($RD3EndDate)) {
        $IsRD3Date = ' ';
      } else {
        $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
      }
      $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND `rd6_reports`.`DesUserID` = '$PerUserID' order by rd6_reports.`RD6ID` DESC";
      $total_pages = mysqli_fetch_array($mysqli->query($query));
      $total_pages = $total_pages['num'];

      $limit = 25;
      if ($Page) {
        $start = ($Page - 1) * $limit;
      } else {
        $start = 0;
      }

      $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND `rd6_reports`.`DesUserID` = '$PerUserID' order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
      $numrows = mysqli_num_rows($res);
      if ($numrows > 0) {
        while ($row = $res->fetch_assoc()) {
          $dt = new DateTime($row['CreatedAt']);
          $DATE = $dt->format('d-m-Y');
          $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
          $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
          $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
          $return[$row['RD6ID']]['StageID'] = $row['FVID'];
          $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
          $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
          $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
          $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
          $return[$row['RD6ID']]['Status'] = $row['des_status'];
          if ($row['RD3Status'] != 1) {
            $return[$row['RD6ID']]['RD3Status'] = 2;
            $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
          } else {
            $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
            $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
          }

          $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
          $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
          $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
          $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
          $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

          $return[$row['RD6ID']]['CreatedAt'] = $DATE;
          $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
          if (mysqli_num_rows($res144) == 0) {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
          } else {
            $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
            $row88 = mysqli_fetch_array($resx88);
            if ($row88['Status'] == 1 or $row88['Status'] == 2) {
              $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
            } else {
              $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
            }
          }
          $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");          $numrows11 = mysqli_num_rows($res122);
          $return[$row['RD6ID']]["TicketNum"] = $numrows11;
          $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
          $row88 = mysqli_fetch_array($resx88);
          $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
          $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
          $row910 = mysqli_fetch_array($res910);
          if ($row910['Type'] == 0) {
            $return[$row['RD6ID']]['SubContractor'] = False;
          } else if ($row910['Type'] == 1) {
            $return[$row['RD6ID']]['SubContractor'] = True;
          }
          $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
          $numrows1 = mysqli_num_rows($res11);
          if ($numrows1 > 0) {
            $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
            $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
          } else {
            $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
            $row99 = mysqli_fetch_array($res99);
            $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
            $row89 = mysqli_fetch_array($resx89);
            $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
            $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
          }

          $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
          $row8 = mysqli_fetch_array($resx8);
          $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

          $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
          $row11 = mysqli_fetch_array($resx11);
          $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
          $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
          $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
          $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
          $row12 = mysqli_fetch_array($resx12);
          $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
          $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
          $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

          $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
          $row16 = mysqli_fetch_array($resx16);
          $return[$row['RD6ID']]['Category'] = $row16['Name'];

          $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
          $row10 = mysqli_fetch_array($resx10);
          $return[$row['RD6ID']]['Cost'] = $row10['Cost'];

          $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
          $row1 = mysqli_num_rows($res1);

          if ($row1 != 0) {
            $return[$row['RD6ID']]['InsReport'] = true;
          } else {
            $return[$row['RD6ID']]['InsReport'] = false;
          }

          $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
          $row3 = mysqli_num_rows($res3);

          if ($row3 != 0) {
            $return[$row['RD6ID']]['DesReport'] = true;
          } else {
            $return[$row['RD6ID']]['DesReport'] = false;
          }

          $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
          $row81r009 = mysqli_fetch_array($resx81r990);
          $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

          $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
          $row9 = mysqli_fetch_array($res9);
          $return[$row['RD6ID']]['Description'] = $row9['Description'];

          $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
          $ro5967 = mysqli_fetch_array($resx955);
          $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
          $row967 = mysqli_fetch_array($resx9);
          $n56722 = mysqli_num_rows($resx9);

          if ($n56722 != 0) {
            $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
          } else {
            $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
          }
        }
        $lastpage = ceil($total_pages / $limit);
        $return["TotalItems"] = $total_pages;
        $return["TotalPages"] = $lastpage;
        $return["Page"] = $Page;
        $return["error"] = false;
      } else {
        $return["error"] = true;
        $return["message"] = "Not Found!";
      }
    }
  } else {

    if (empty($Page)) {
      $Page = 1;
    } else {
      $Page = $Pos->Page;
    }
    if (empty($ReportID)) {
      $ReportIDs = ' ';
    } else {
      $ReportIDs = " and `rd6_reports`.`RD6ID` in ($ReportID) ";
    }
    if (empty($ReferenceNo)) {
      $ReferenceNoa = ' ';
    } else {
      $ReferenceNoa = " and projects.ReferenceNo in ($ReferenceNo) ";
    }
    if (empty($Category)) {
      $CategoryID = ' ';
    } else {
      $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
    }
    if (empty($ReportShow)) {
      $ReportShows = ' ';
    } else {
      $ReportShows = " and `rd6_reports`.`des_status` = 'InProgress' ";
    }
    if (empty($RD6Status)) {
      $Statusa = ' ';
    } else {
      $RD6Status = "'" . str_replace(",", "','", $RD6Status) . "'";
      $Statusa = "  and `rd6_reports`.`Status` in ($RD6Status) ";
    }
    if (empty($RD3Status)) {
      $RD3Statusa = ' ';
    } else {
      $RD3Status = "'" . str_replace(",", "','", $RD3Status) . "'";
      $RD3Statusa = "  and `rd6_reports`.`RD3Status` in ($RD3Status) ";
    }
    if (empty($Designer)) {
      $Designers = ' ';
    } else {
      $Designers = " and rd6_reports.DesUserID in ($Designer) ";
    }
    if (empty($Inspector)) {
      $Inspectors = ' ';
    } else {
      $Inspectors = " and rd6_reports.InsUserID in ($Inspector) ";
    }
    if (empty($CostFrom) && empty($CostTo)) {
      $IsCost = ' ';
    } else {
      $IsCost = " and `project_costs`.`Cost` between '$CostFrom' and '$CostTo' ";
    }
    if (empty($StartDate) && empty($EndDate)) {
      $IsDate = ' ';
    } else {
      $IsDate = " and `rd6_reports`.`CreatedAt` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
    }
    if (empty($RD3StartDate) && empty($RD3EndDate)) {
      $IsRD3Date = ' ';
    } else {
      $IsRD3Date = " and `rd6_reports`.`RD3Date` between '$RD3StartDate 00:00:00' and '$RD3EndDate 23:59:59' ";
    }
    $query = "SELECT COUNT(rd6_reports.`RD6ID`) as num from rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND `rd6_reports`.`DesUserID` = '$PerUserID' order by rd6_reports.`RD6ID` DESC";
    $total_pages = mysqli_fetch_array($mysqli->query($query));
    $total_pages = $total_pages['num'];

    $limit = 25;
    if ($Page) {
      $start = ($Page - 1) * $limit;
    } else {
      $start = 0;
    }

    $res = $mysqli->query("SELECT rd6_reports.*, projects.OwnerID as OID, projects.ConstructorID as CID,projects.ReferenceNo, projects.CategoryID,  `projects`.`ProjectType` FROM rd6_reports, projects, project_costs where rd6_reports.ProjectID = projects.ProjectID and projects.ProjectID = project_costs.ProjectID and projects.ProjectID = project_costs.ProjectID and  rd6_reports.Deleted = '0'  $ReportIDs $ReferenceNoa $ReportShows  $CategoryID  $Statusa  $RD3Statusa $Designers $InProgress1 $InProgress2 $InProgress3 $InProgress4 $InProgress5 $Inspectors $IsCost  $IsDate $IsRD3Date AND `rd6_reports`.`DesUserID` = '$PerUserID' order by rd6_reports.`RD6ID` DESC LIMIT $start, $limit");
    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
      while ($row = $res->fetch_assoc()) {
        $dt = new DateTime($row['CreatedAt']);
        $DATE = $dt->format('d-m-Y');
        $return[$row['RD6ID']]['RD6ID'] = $row['RD6ID'];
        $return[$row['RD6ID']]['ProjectID'] = $row['ProjectID'];
        $return[$row['RD6ID']]['ReferenceNo'] = $row['ReferenceNo'];
        $return[$row['RD6ID']]['StageID'] = $row['FVID'];
        $return[$row['RD6ID']]['PStageID'] = $row['PStageID'];
        $return[$row['RD6ID']]['InsUserID'] = $row['InsUserID'];
        $return[$row['RD6ID']]['DesUserID'] = $row['DesUserID'];
        $return[$row['RD6ID']]['DesMangerName'] = 'Mahmoud Elmasry';
        $return[$row['RD6ID']]['Status'] = $row['des_status'];
        if ($row['RD3Status'] != 1) {
          $return[$row['RD6ID']]['RD3Status'] = 2;
          $return[$row['RD6ID']]['RD3Date'] = date('d-M-Y', strtotime($DATE . ' + 9 months'));
        } else {
          $return[$row['RD6ID']]['RD3Status'] = $row['RD3Status'];
          $return[$row['RD6ID']]['RD3Date'] = $row['RD3Date'];
        }

        $return[$row['RD6ID']]['ReportStatus'] = $row['Status'];
        $return[$row['RD6ID']]['InsStatus'] = $row['ins_status'];
        $return[$row['RD6ID']]['InsrevStatus'] = $row['insrev_status'];
        $return[$row['RD6ID']]['DesStatus'] = $row['des_status'];
        $return[$row['RD6ID']]['QCStatus'] = $row['QC_status'];

        $return[$row['RD6ID']]['CreatedAt'] = $DATE;
        $res144 = $mysqli->query("SELECT  t.TicketID FROM Ticket t JOIN projects p ON t.ProjectID = p.ProjectID LEFT JOIN (SELECT TicketHistory.TicketID, MAX(TicketHistory.THID) AS MaxTHID FROM TicketHistory GROUP BY TicketHistory.TicketID) th_max ON t.TicketID = th_max.TicketID LEFT JOIN TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID WHERE
        t.ProjectID = '$ProjectID' AND  th.`DegreeID` not in (4,12,11,10,3) and t.`Deleted` = '0'");
        if (mysqli_num_rows($res144) == 0) {
          $return[$row['RD6ID']]['Addendum_Status'] = 'Not requiered';
        } else {
          $resx88 = $mysqli->query("SELECT `Status` FROM `RD6_Addendum` WHERE `ProjectID` = '" . $row['ProjectID'] . "' AND `Deleted` = '0'");
          $row88 = mysqli_fetch_array($resx88);
          if ($row88['Status'] == 1 or $row88['Status'] == 2) {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Confirmed';
          } else {
            $return[$row['RD6ID']]['Addendum_Status'] = 'Pending';
          }
        }
        $return[$row['RD6ID']]['Type'] = $row['ProjectType'];
      $res122 = $mysqli->query("SELECT 
    t.TicketID 
FROM 
    Ticket t
LEFT JOIN 
    (
        SELECT 
            TicketHistory.TicketID, 
            MAX(TicketHistory.THID) AS MaxTHID
        FROM 
            TicketHistory
        GROUP BY 
            TicketHistory.TicketID
    ) th_max ON t.TicketID = th_max.TicketID
LEFT JOIN 
    TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
WHERE 
    t.ProjectID = '" . $row['ProjectID'] . "' 
    AND (th.DegreeID <> '4' OR th.DegreeID <> '12' OR th.DegreeID IS NULL) 
    AND t.Deleted = '0'
");        $numrows11 = mysqli_num_rows($res122);
        $return[$row['RD6ID']]["TicketNum"] = $numrows11;
        $resx88 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row['InsUserID'] . "'");
        $row88 = mysqli_fetch_array($resx88);
        $return[$row['RD6ID']]['InspectionName'] = $row88['FirstName'] . " " . $row88['LastName'];
        $res910 = $mysqli->query("SELECT `org_chart`.`Type`FROM `org_chart`, `user_chart` WHERE `org_chart`.`OCID` = `user_chart`.`OCID` AND `user_chart`.`UserID` = '" . $row['DesUserID'] . "'");
        $row910 = mysqli_fetch_array($res910);
        if ($row910['Type'] == 0) {
          $return[$row['RD6ID']]['SubContractor'] = False;
        } else if ($row910['Type'] == 1) {
          $return[$row['RD6ID']]['SubContractor'] = True;
        }
        $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='" . $row['InsUserID'] . "'");
        $numrows1 = mysqli_num_rows($res11);
        if ($numrows1 > 0) {
          $return[$row['RD6ID']]['AreaManagerName'] = $row88['FirstName'] . " " . $row88['LastName'];
          $return[$row['RD6ID']]['AreaManagerID'] = $row['InsUserID'];
        } else {
          $res99 = $mysqli->query("SELECT `Supervisor` FROM `org_chart` WHERE `OCID` = (SELECT `OCID` FROM `user_chart` WHERE `UserID` = '" . $row['InsUserID'] . "')");
          $row99 = mysqli_fetch_array($res99);
          $resx89 = $mysqli->query("SELECT  FirstName, LastName FROM `users` where `UserID` = '" . $row99['Supervisor'] . "'");
          $row89 = mysqli_fetch_array($resx89);
          $return[$row['RD6ID']]['AreaManagerName'] = $row89['FirstName'] . " " . $row89['LastName'];
          $return[$row['RD6ID']]['AreaManagerID'] = $row99['Supervisor'];
        }

        $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['DesUserID'] . "'");
        $row8 = mysqli_fetch_array($resx8);
        $return[$row['RD6ID']]['DesignName'] = $row8['FirstName'] . " " . $row8['LastName'];

        $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
        $row11 = mysqli_fetch_array($resx11);
        $return[$row['RD6ID']]['OwnerMobile'] = $row11['Mobile'];
        $return[$row['RD6ID']]['OwnerEmail'] = $row11['Email'];
        $return[$row['RD6ID']]['OwnerName'] = $row11['Name'];
        $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
        $row12 = mysqli_fetch_array($resx12);
        $return[$row['RD6ID']]['ConstructorMobile'] = $row12['Mobile'];
        $return[$row['RD6ID']]['ConstructorEmail'] = $row12['Email'];
        $return[$row['RD6ID']]['ConstructorName'] = $row12['Name'];

        $resx16 = $mysqli->query("SELECT Name FROM `building_category` where `BCID` = '" . $row['CategoryID'] . "'");
        $row16 = mysqli_fetch_array($resx16);
        $return[$row['RD6ID']]['Category'] = $row16['Name'];

        $resx10 = $mysqli->query("SELECT `Cost` FROM `project_costs` where `ProjectID` = '" . $row['ProjectID'] . "'");
        $row10 = mysqli_fetch_array($resx10);
        $return[$row['RD6ID']]['Cost'] = $row10['Cost'];

        $res1 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '1'");
        $row1 = mysqli_num_rows($res1);

        if ($row1 != 0) {
          $return[$row['RD6ID']]['InsReport'] = true;
        } else {
          $return[$row['RD6ID']]['InsReport'] = false;
        }

        $res3 = $mysqli->query("SELECT `RD6HID` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' AND `Action` = '5'");
        $row3 = mysqli_num_rows($res3);

        if ($row3 != 0) {
          $return[$row['RD6ID']]['DesReport'] = true;
        } else {
          $return[$row['RD6ID']]['DesReport'] = false;
        }

        $resx81r990 = $mysqli->query("SELECT CreatedAt FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "'");
        $row81r009 = mysqli_fetch_array($resx81r990);
        $return[$row['RD6ID']]['LastUpdate'] = $row81r009['CreatedAt'];

        $res9 = $mysqli->query("SELECT `Description` FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
        $row9 = mysqli_fetch_array($res9);
        $return[$row['RD6ID']]['Description'] = $row9['Description'];

        $resx955 = $mysqli->query("SELECT UpdaterID FROM `rd6_history` where `RD6ID` = '" . $row['RD6ID'] . "' order by RD6HID desc limit 1");
        $ro5967 = mysqli_fetch_array($resx955);
        $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
        $row967 = mysqli_fetch_array($resx9);
        $n56722 = mysqli_num_rows($resx9);

        if ($n56722 != 0) {
          $return[$row['RD6ID']]['LastUpdateBy'] = $row967['FirstName'] . " " . $row967['LastName'];
        } else {
          $return[$row['RD6ID']]['LastUpdateBy'] = NULL;
        }
      }
      $lastpage = ceil($total_pages / $limit);
      $return["TotalItems"] = $total_pages;
      $return["TotalPages"] = $lastpage;
      $return["Page"] = $Page;
      $return["error"] = false;
    } else {
      $return["error"] = true;
      $return["message"] = "Not Found!";
    }
  }
} else {
  $return["error"] = true;
  $return["message"] = "Access denied!";
}


$return['cleanReport'] = true;
header('Content-Type: application/json');
echo json_encode($return);
