<?php
ob_start('ob_gzhandler');
include('../api/config.php');

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$TicketID = trim($Data->TicketID);

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {

    $res = $mysqli->query("SELECT 
        t.TicketID, 
        t.ProjectID, 
        t.StageID, 
        t.PStageID, 
        t.Description, 
        t.UserID, 
        t.Code, 
        t.CreatedAt, 
        p.ReferenceNo,
        th.`DegreeID`, 
        th.`TransferTo`, 
        th.`CommentEN`,
        th.`CommentAR`, 
        th.`CorrectiveEN`, 
        th.`CorrectiveAR`,
        th.`File` 
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
       t.TicketID = '$TicketID'");
    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {

        while ($row209 = $res->fetch_assoc()) {

            $return["error"] = false;
            $ProjectID = $row209['ProjectID'];
            $PStageID = $row209['PStageID'];
            $file_urls = [];

        $files = explode(',', $row209['File']);
        if (empty($files) || (count($files) == 1 && empty(trim($files[0], '[]"')))) {
          //  $file_urls[] = 'Empty';  // Indicate that the file is empty
        } else {
            $files = explode(',', $row209['File']);
            foreach ($files as $file) {
                $file = trim($file, '[]"');
                $file_url = "https://rd0.cpvarabia.com/uploads/inspection/" . $file;
                $file_urls[] = $file_url;
            }
        }
        

            $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row209['UserID'] . "'");
            $row9 = mysqli_fetch_array($resx9);

            $return['Ticket'] = [
                'TicketID' => $row209['TicketID'],
                'StageID' => $row209['StageID'],
                'Description' => $row209['Description'],
                'UserID' => $row209['UserID'],
                'UserName' => $row9['FirstName'] . " " . $row9['LastName'],
                'Code' => $row209['Code'],
                'CreatedAt' => $row209['CreatedAt'],
                'DegreeID' => $row209['DegreeID'],
                'TransferTo' => $row209['TransferTo'],
                'CommentEN' => $row209['CommentEN'],
                'CommentAR' => $row209['CommentAR'],
                'CorrectiveEN' => $row209['CorrectiveEN'],
                'CorrectiveAR' => $row209['CorrectiveAR'],
                'Attached' => $file_urls,
                'ReferenceNo' => $row209['ReferenceNo'],
                'History' => [],
                'Description_Drive' => [],
                'Solving_Data' => [],
                'Project_info' => [],
                'Ins_Stages' => [],
            ];

            $resrd5 = $mysqli->query("SELECT `THID`,`TicketID`,`CommentEN`,`CommentAR`,`CorrectiveEN`,`CorrectiveAR`,`TransferTo`,`DegreeID`,`UpdaterID`,`File`, `SolvingData`,`CreatedAt` FROM `TicketHistory` WHERE `TicketID` ='$TicketID' AND `Deleted` = '0' ORDER BY `TicketHistory`.`THID` ASC");

$numrows12 = mysqli_num_rows($resrd5);
if ($numrows12 > 0) {
    $i = 1;
    while ($rowrd5 = $resrd5->fetch_assoc()) {
        $dt = new DateTime($rowrd5['CreatedAt']);
        $issue_date = $dt->format('d-M-Y');

        $resx81r = $mysqli->query("SELECT Name, Category FROM `tickets_degree` where `DegreeID` = '" . $rowrd5['DegreeID'] . "'");
        $row81r = mysqli_fetch_array($resx81r);
        $resx88r = $mysqli->query("SELECT Name FROM `role_resources` where `ResourceID` = '" . $rowrd5['TransferTo'] . "'");
        $row88r = mysqli_fetch_array($resx88r);
        $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $rowrd5['UpdaterID'] . "'");
        $row9 = mysqli_fetch_array($resx9);

        $file_urls = [];

        $files = explode(',', $rowrd5['File']);
        if (empty($files) || (count($files) == 1 && empty(trim($files[0], '[]"')))) {
          //  $file_urls[] = 'Empty';  // Indicate that the file is empty
        } else {
            foreach ($files as $file) {
                $file = trim($file, '[]"');
                if (!empty($file)) {
                    $file_url = "https://rd0.cpvarabia.com/uploads/inspection/" . $file;
                    $file_urls[] = $file_url;
                }
            }
        }

        $return['Ticket']['History'][] = [
            'CommentEN' => $rowrd5['CommentEN'] . $rowrd5['SolvingData'],
            'CommentAR' => $rowrd5['CommentAR'],
            'CorrectiveEN' => $rowrd5['CorrectiveEN'],
            'CorrectiveAR' => $rowrd5['CorrectiveAR'],
            'UserName' => $row9['FirstName'] . " " . $row9['LastName'],
            'UpdateID' => $rowrd5['TicketID'] . '-' . $i,
            'Action' => $row81r['Name'] . $row88r['Name'],
            'CreatedAt' => $issue_date,
            'File' => $file_urls,
        ];
        $i++;
    }
}

            $resrd55 = $mysqli->query("SELECT `THID`,`TicketID`,`TransferTo`,`DegreeID`,`UpdaterID`,`File`,`CreatedAt` FROM `TicketHistory` WHERE `TicketID` ='$TicketID' AND `File` is not null AND `DegreeID` NOT in (4,12) AND `Deleted` = '0' ORDER BY `TicketHistory`.`THID` ASC");
            $numrows122 = mysqli_num_rows($resrd55);
            if ($numrows122 > 0) {
                $ix = 1;
                while ($rowrd55 = $resrd55->fetch_assoc()) {

                    $resx81r = $mysqli->query("SELECT Name, Category FROM `tickets_degree` where `DegreeID` = '" . $rowrd55['DegreeID'] . "'");
                    $row81r = mysqli_fetch_array($resx81r);
                    $resx88r = $mysqli->query("SELECT Name FROM `role_resources` where `ResourceID` = '" . $rowrd55['TransferTo'] . "'");
                    $row88r = mysqli_fetch_array($resx88r);
                    $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $rowrd55['UpdaterID'] . "'");
                    $row9 = mysqli_fetch_array($resx9);

                    $files = explode(',', $rowrd55['File']);
                    foreach ($files as $file) {
                        $file = trim($file, '[]"');
                        $file_url = "https://rd0.cpvarabia.com/uploads/inspection/" . $file;

                        $return['Ticket']['Description_Drive'][] = [
                            'FileNamne' => $file,
                            'UserName' => $row9['FirstName'] . " " . $row9['LastName'],
                            'UpdateID' => $rowrd55['TicketID'] . '-' . $ix,
                            'Action' => $row81r['Name'] . $row88r['Name'],
                            'CreatedAt' => $rowrd55['CreatedAt'],
                            'File' => $file_url,
                        ];
                    }
                    $ix++;
                }
            }

            $resrd5 = $mysqli->query("SELECT `StageID`,`InspectorID`,`StageDate`,`InspectorID`,`RResult` FROM `project_stages` WHERE `StageID` in (61,60,48,56,57,58,59,6,5,4,3) AND `Synced` = '1' AND `Deleted` = '0' and `ProjectID` = '$ProjectID' and `Token` is not null ORDER BY `project_stages`.`PStageID` DESC");

            $numrows12 = mysqli_num_rows($resrd5);
            if ($numrows12 > 0) {
                $i = 1;
                while ($rowrd5 = $resrd5->fetch_assoc()) {
                    $dt = new DateTime($rowrd5['StageDate']);
                    $issue_date = $dt->format('d-M-Y');


                    $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $rowrd5['InspectorID'] . "' limit 1");
                    $row9 = mysqli_fetch_array($resx9);

                    $D23429 = $mysqli->query("SELECT StageName FROM `stages` where `StageID` = '" . $rowrd5['StageID'] . "' limit 1");
                    $We5563d = mysqli_fetch_array($D23429, MYSQLI_ASSOC);

                    if ($rowrd5['RResult'] == 1) {
                        $RResult = 'RD5 WI';
                    } else if ($rowrd5['RResult'] == 2) {
                        $RResult = 'RD5 MS';
                    } else if ($rowrd5['RResult'] == 3 or $rowrd5['RResult'] == 4) {
                        $RResult = 'Additional Vsit';
                    } else if ($rowrd5['RResult'] == 5) {
                        $RResult = 'Satisfactory with Technical Reservation';
                    } else if ($rowrd5['RResult'] == 6) {
                        $RResult = 'Satisfactory with Note';
                    } else {
                        $RResult = 'Satisfactory';
                    }

                    $return['Ticket']['Ins_Stages'][] = [
                        'StageName' => $We5563d['StageName'],
                        'Result' => $RResult,
                        'UserName' => $row9['FirstName'] . " " . $row9['LastName'],
                        'CreatedAt' => $issue_date,

                    ];
                }
            }

            $resrd51 = $mysqli->query("SELECT `THID`,`TicketID`,`TransferTo`,`DegreeID`,`UpdaterID`,`File`,`CreatedAt` FROM `TicketHistory` WHERE `TicketID` ='$TicketID' AND `File` is not null AND `DegreeID` in (4,12) AND `Deleted` = '0' ORDER BY `TicketHistory`.`THID` ASC");
            $numrows121 = mysqli_num_rows($resrd51);
            if ($numrows121 > 0) {
                $x = 1;
                while ($rowrd51 = $resrd51->fetch_assoc()) {
                    $dt = new DateTime($rowrd51['CreatedAt']);
                    $issue_date = $dt->format('d-M-Y');

                    $resx81r = $mysqli->query("SELECT Name, Category FROM `tickets_degree` where `DegreeID` = '" . $rowrd51['DegreeID'] . "'");
                    $row81r = mysqli_fetch_array($resx81r);
                    $resx88r = $mysqli->query("SELECT Name FROM `role_resources` where `ResourceID` = '" . $rowrd51['TransferTo'] . "'");
                    $row88r = mysqli_fetch_array($resx88r);
                    $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $rowrd51['UpdaterID'] . "'");
                    $row9 = mysqli_fetch_array($resx9);

                    $files = explode(',', $rowrd51['File']);
                    foreach ($files as $file) {
                        $file = trim($file, '[]"');
                        $file_url = "https://rd0.cpvarabia.com/uploads/inspection/" . $file;

                        $return['Ticket']['Solving_Data'][] = [
                            'FileNamne' => $file,
                            'UserName' => $row9['FirstName'] . " " . $row9['LastName'],
                            'UpdateID' => $rowrd51['TicketID'] . '-' . $x,
                            'Action' => $row81r['Name'] . $row88r['Name'],
                            'CreatedAt' => $issue_date,
                            'File' => $file_url,
                        ];
                    }
                    $x++;
                }
            }

            $resrd5 = $mysqli->query("SELECT `projects`.`CityID`,`projects`.`CategoryID`,`project_stages`.`PStageID` FROM `projects`,`project_stages` WHERE `projects`.`ProjectID` = `project_stages`.ProjectID AND `project_stages`.`StageID` = '10' AND `project_stages`.`ProjectID` = '$ProjectID' AND `project_stages`.`Deleted` = '0' ORDER BY `project_stages`.`PStageID` DESC  LIMIT 1 ");

            $numrows12 = mysqli_num_rows($resrd5);
            if ($numrows12 > 0) {
                while ($rowrd5 = $resrd5->fetch_assoc()) {
                    $CityID = $rowrd5['CityID'];
                    $CategoryID = $rowrd5['CategoryID'];
                    $RD0PStageID = $rowrd5['PStageID'];

                    $res_cost = $mysqli->query("SELECT * FROM `project_costs` where `ProjectID` = '$ProjectID'");
                    $row_cost = mysqli_fetch_array($res_cost);
                    $Total_cost = $row_cost['Cost'];
                    $Total_cost1 = number_format($Total_cost, 2, ".", ",");

                    $res_City = $mysqli->query("SELECT `CityNameEN` FROM `cities` WHERE `CityID` = '$CityID'");
                    $row_City = mysqli_fetch_array($res_cost);
                    $CityName = $row_City['CityNameEN'];

                    $res7 = $mysqli->query("SELECT * FROM `building_category` where `BCID` = '$CategoryID'");
                    while ($row7 = mysqli_fetch_array($res7)) {
                        $OCCUPATION = $row7['Name'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '32'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D176 = $row5['Answer'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '239'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D22 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '1927'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1927 = $row5['QID'];
                    }
                    $res15 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '394'");
                    while ($row15 = mysqli_fetch_array($res15)) {
                        $D167 = $row15['QID'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '226'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D168 = $row5['Answer'];
                    }

                    if ($D167 != null) {
                        $P595 = ' and ';
                        if ($D168 > 1) {
                            $P596 = ' basements ';
                        } else {
                            $P596 = ' basement ';
                        }
                    } else {
                        $P595 = '';
                        $P596 = '';
                    }

                    if ($D22 > 1) {
                        $D22F = ' floors ';
                    } else {
                        $D22F = ' floor ';
                    }

                    if (!empty($D1927)) {
                        $D22A = ' with annex ';
                    } else {
                        $D22A = '';
                    }

                    if ($D22 > 1) {
                        $D22F = ' floors ';
                    } else {
                        $D22F = ' floor ';
                    }

                    if (!empty($D1927)) {
                        $D22A = ' with annex ';
                    } else {
                        $D22A = '';
                    }

                    //---------------------
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1249' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1249 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1250' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1250 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1251' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1251 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1252' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1252 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1253' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1253 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1254' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1254 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1255' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1255 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1256' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1256 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1257' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1257 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1258' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1258 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1259' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1259 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1260' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1260 = $row5['Answer'];
                    }



                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1258' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1258 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1251' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1251 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1252' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1252 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '1255' ");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1255 = $row5['Answer'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '475'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D67 = $row5['Answer'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '77'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D103 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '231'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D55 = $row5['Answer'];
                    }

                    //---------------

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '427'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D113 = $row5['QID'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '428'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D114 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '429'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D115 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '430'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D116 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '1944'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D1944 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '437'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D4 = $row5['QID'];
                    }
                    if ($D113 != NULL) {
                        $A547 = 'Isolated Footings';
                    } else {
                        $A547 = '';
                    }

                    if ($D114 != NULL) {
                        $A548 = 'Raft Foundation';
                    } else {
                        $A548 = '';
                    }

                    if ($D115 != NULL) {
                        $A549 = 'Strip Footings';
                    } else {
                        $A549 = '';
                    }

                    if ($D116 != NULL) {
                        $A550 = 'Tie beams';
                    } else {
                        $A550 = '';
                    }
                    if ($D1944 != NULL) {
                        $A1944 = 'Combined Footings';
                    } else {
                        $A1944 = '';
                    }

                    if (!empty($D4)) {
                        $A552 = 'Piles';
                    } else {
                        $A552 = '';
                    }

                    if (empty($A547)) {
                        $S547 = '';
                    } else {
                        $S547 = ',';
                    }
                    if (empty($A548)) {
                        $S548 = '';
                    } else {
                        $S548 = ',';
                    }
                    if (empty($A549)) {
                        $S549 = '';
                    } else {
                        $S549 = ',';
                    }
                    if (empty($A550)) {
                        $S550 = '';
                    } else {
                        $S550 = ',';
                    }
                    if (empty($A552)) {
                        $S552 = '';
                    } else {
                        $S552 = ',';
                    }

                    //code 5
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '732'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D92 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '733'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D93 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '734'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D94 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '735'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D95 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '736'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D96 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '737'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D97 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '738'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D98 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '739'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D99 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '442'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D9 = $row5['QID'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '740'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D100 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `OptionID` = '741'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D101 = $row5['QID'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '411'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D102 = $row5['Answer'];
                    }

                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '75'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D88 = $row5['Answer'];
                    }
                    $res5 = $mysqli->query("SELECT * FROM `rd0_answers` where `PStageID` = '$RD0PStageID' and `QID` = '74'");
                    while ($row5 = mysqli_fetch_array($res5)) {
                        $D89 = $row5['Answer'];
                    }
                    if ($D92 == null) {
                        $D92S = false;
                    } else {
                        $D92S = true;
                        $B92S = 'Sabkha Soil.';
                    }
                    if ($D93 == null) {
                        $D93S = false;
                    } else {
                        $D93S = true;
                        $B93S = 'Soft Clay.';
                    }
                    if ($D94 == null) {
                        $D94S = false;
                    } else {
                        $D94S = true;
                        $B94S = 'Expansive Soil or Swelling Soil.';
                    }
                    if ($D95 == null) {
                        $D95S = false;
                    } else {
                        $D95S = true;
                        $B95S = 'Collapse Soil.';
                    }
                    if ($D96 == null) {
                        $D96S = false;
                    } else {
                        $D96S = true;
                        $B96S = 'Loess Soil.';
                    }
                    if ($D97 == null) {
                        $D97S = false;
                    } else {
                        $D97S = true;
                        $B97S = 'Karst Soil.';
                    }
                    if ($D98 == null) {
                        $D98S = false;
                    } else {
                        $D98S = true;
                        $B98S = 'Liquefaction Soil.';
                    }
                    if ($D99 == null) {
                        $D99S = false;
                    } else {
                        $D99S = true;
                        $B99S = 'Fill Soil.';
                    }
                    if ($D100 == null) {
                        $D100S = false;
                    } else {
                        $D100S = true;
                        $B100S = 'Compressible Soil.';
                    }
                    if ($D101 == null) {
                        $D101S = false;
                    } else {
                        $D101S = true;
                        $B101S = 'Non Homogenous Soil.';
                    }

                    if ($D102 == null) {
                        $D641 = false;
                    } else {
                        $D641 = true;
                        $B641S = $D102;
                    }

                    if (($D88 - $D89) > 0.3) {
                        $D642 = true;
                        $B642S = 'Founding on replacement soil.';
                    } else {
                        $D642 = false;
                    }

                    $TfSoil = array($D92S, $D93S, $D94S, $D95S, $D96S, $D97S, $D98S, $D99S, $D100S, $D101S, $D641, $D642);
                    $TfSoilcode = array('X', 'X', 'X', 'X', 'X', 'P', 'X', 'X', 'V', 'X', 'X', 'W');


                    if (count(array_keys($TfSoil, true)) == 0) {
                        $Code5text = 'No Ground Specific Risks';
                    } elseif (count(array_keys($TfSoil, true)) > 1) {
                        $Code5text = $B92S . $B93S . $B94S . $B95S . $B96S . $B97S . $B98S . $B99S . $B100S . $B101S . $B641S . $B642S;
                    } elseif (count(array_keys($TfSoil, true)) == 1) {
                        $Code5text = $B92S . $B93S . $B94S . $B95S . $B96S . $B97S . $B98S . $B99S . $B100S . $B101S . $B641S . $B642S;
                    }
                    $ftype = $A547 . $S547 . $A548 . $S548 . $A549 . $S549 . $A550 . $S550 . $A552 . $S552 . $A1944;
                    $D135 = max($D1251, $D1252, $D1255, $D1258);
                    $G323 = max($D1249, $D1250, $D1253, $D1254, $D1256, $D1257, $D1259, $D1260);
                    //----------------------------------------


                    $return['Ticket']['Project_info']['Project_General_info'] = [
                        [
                            'name' => 'Cost',
                            'value' => $Total_cost1,
                        ],
                        [
                            'name' => 'Location',
                            'value' => $CityName,
                        ],
                        [
                            'name' => 'Building Type',
                            'value' => $OCCUPATION,
                        ]
                    ];
                    $return['Ticket']['Project_info']['Structural_info'] = [
                        [
                            'name' => 'Clear height',
                            'value' => $D176 . ' m',
                        ],
                        [
                            'name' => 'No of floors',
                            'value' => $D22 . $D22F . $D22A . $P595 . $D168 . $P596,
                        ],
                        [
                            'name' => 'Maximum Span',
                            'value' => $G323 . ' m',
                        ],
                        [
                            'name' => 'Maximum Span (Cantilever)',
                            'value' => $D135 . ' m',
                        ]
                    ];

                    $return['Ticket']['Project_info']['Soil_info'] = [
                        [
                            'name' => 'BC',
                            'value' => $D67 . ' kg/m',
                        ],
                        [
                            'name' => 'Settlement',
                            'value' => $D103 . ' mm',
                        ],
                        [
                            'name' => 'Soil Type',
                            'value' => $D55,
                        ],
                        [
                            'name' => 'Code5',
                            'value' => $Code5text,
                        ],
                        [
                            'name' => 'Foundation Type',
                            'value' => $ftype,
                        ],
                        [
                            'name' => 'Foundation Level',
                            'value' => $D88 . ' m',
                        ]
                    ];
                }
            }
        }
    } else {
        $return["error"] = true;
        $return["message"] = "Incorrect!";
    }
}

header('Content-Type: application/json');
echo json_encode($return);
