<?php
ob_start('ob_gzhandler');
include('../api/config.php');

$Pos = json_decode(file_get_contents('php://input'));
$PerToken = trim($Pos->PerToken);
$PerUserID = trim($Pos->PerUserID);
$PerRoleID = trim($Pos->PerRoleID);
$Page = $Pos->Page;
$Updaters = $Pos->Updaters;
$Creators = $Pos->Creators;
$Degrees = $Pos->Degrees;
$StartDate = $Pos->StartDate;
$EndDate = $Pos->EndDate;
$TicketID = $Pos->TicketID;
$Code = $Pos->Code;
$ReferenceNo = $Pos->ReferenceNo;
$ViewCreator = $Pos->ViewCreator;
$ViewTransferTo = $Pos->ViewTransferTo;
$TicketsUsers = $Pos->TicketsUsers;
$TicketType = $Pos->TicketType;
$Stage = $Pos->Stage;
//$RD5filter = $Pos->RD5filter;
$DeletedTickets = $Pos->DeletedTickets;
$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {

    if (empty($Page)) {
        $Page = 1;
    } else {
        $Page = $Pos->Page;
    }
    if (empty($ReferenceNo)) {
        $ReferenceNoa = ' ';
    } else {
        if (strlen($ReferenceNo) < 6) {
            $ReferenceNoa = "  and p.ReferenceNo LIKE '$ReferenceNo%' ";
        } else {
            $ReferenceNoa = "  and p.ReferenceNo in ($ReferenceNo) ";
        }
    }

    if ($DeletedTickets) {
        $Deleted = " and t.Deleted = '2'";
    } else {
        $Deleted = " and t.Deleted = '0'";
    }

    //if(empty($Updaters)){$Updatersa = ' ';}else{$Updatersa = "  and t.UpdaterID in ($Updaters) ";}
    $Updatersa = ' ';

    if (!empty($ViewCreator) && empty($ViewTransferTo)) {
        $Viewperm = " and t.`UserID` = '$ViewCreator'";
    } elseif (!empty($ViewCreator) && !empty($ViewTransferTo)) {
        $Viewperm = " and ( t.`UserID` = '$ViewCreator' or t.TransferTo in ($ViewTransferTo) ) ";
    } else {
        $Viewperm = '';
    }
    if (!empty($TicketType)) {
        $TicketTypes = " and StageID in (SELECT `StageID` FROM `stages` WHERE `Category` = '$TicketType' and `Deleted` = '0')";
    } else {
        $TicketTypes = '';
    }
    if (!empty($Stage)) {
        $Stages = " and `t`.`StageID` in ('$Stage')";
    } else {
        $Stages = '';
    }
    if (empty($TicketsUsers)) {
        $TicketsUsersa = ' ';
    } elseif ($TicketsUsers == 200) {
        $TicketsUsersa = "  and t.UserID = '$PerUserID'  ";
    } else {
        $TicketsUsersa = "  and t.TransferTo = '$TicketsUsers' ";
    }
    if (empty($RD5filter)) {
        $RD5filters = ' ';
    } else {
        $RD5filters = " and t.TicketID in (SELECT `TicketID` FROM `rd5_reports` WHERE `Status` = '$RD5filter') ";
    }
    if (empty($TicketID)) {
        $TicketIDa = ' ';
    } else {
        $TicketIDa = "  and t.TicketID in ($TicketID) ";
    }
    if (empty($Code)) {
        $Codea = ' ';
    } else {
        $Code = "'" . str_replace(",", "','", $Code) . "'";
        $Codea = "  and t.Code in ($Code) ";
    }
    if (empty($Creators)) {
        $Creatorsa = ' ';
    } else {
        $Creatorsa = "  and t.UserID in ($Creators) ";
    }
    if (empty($Degrees)) {
        $Degreesa = ' ';
    } else if ($Degrees == 'null') {
        $Degreesa = "  and th.DegreeID is null ";
    } else {
        $Degrees = "'" . str_replace(",", "','", $Degrees) . "'";
        $Degreesa = "  and th.DegreeID in ($Degrees) ";
    }
    if (empty($StartDate) && empty($EndDate)) {
        $IsDate = ' ';
    } else {
        $IsDate = "  and t.CreatedAt between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
    }
    if (empty($Updaters)) {
        
        $query = "SELECT COUNT(t.TicketID) as num 
        FROM 
            Ticket t
        JOIN 
            projects p ON t.ProjectID = p.ProjectID 
        LEFT JOIN 
            (
                SELECT 
                    TicketHistory.TicketID, 
                    MAX(TicketHistory.THID) AS MaxTHID
                FROM 
                    TicketHistory
                     Where  TicketHistory.DegreeID is not null or TicketHistory.TransferTo is not null
                GROUP BY 
                    TicketHistory.TicketID
            ) th_max ON t.TicketID = th_max.TicketID
        LEFT JOIN 
            TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
        WHERE 
            1=1
            $RD5filters 
            $ReferenceNoa 
            $Codea 
            $TicketIDa 
            $TicketsUsersa 
            $Creatorsa 
            $Degreesa 
            $IsDate 
            $Viewperm 
            $Stages 
            $TicketTypes 
            $Deleted  
            
        ORDER BY 
            t.TicketID DESC";
        $total_pages = mysqli_fetch_array($mysqli->query($query));
        $total_pages = $total_pages['num'];

        $limit = 25;
        if ($Page) {
            $start = ($Page - 1) * $limit;
        } else {
            $start = 0;
        }

     $res = $mysqli->query("
    SELECT 
        t.TicketID, 
        t.ProjectID, 
        t.TransferTo as TT,
        t.StageID, 
        t.Description, 
        t.UserID, 
        t.Code, 
        t.CreatedAt, 
        p.OwnerID as OID, 
        p.ConstructorID as CID,
        p.ReferenceNo,
        th.`THID`,th.`CommentEN`,th.`CommentAR`,th.`CorrectiveEN`,th.`CorrectiveAR`,th.`TransferTo`,th.`UpdaterID`,th.`DegreeID`,th.`File`
    FROM 
        Ticket t
    JOIN 
        projects p ON t.ProjectID = p.ProjectID 
    LEFT JOIN 
        (
            SELECT 
                TicketHistory.TicketID, 
                MAX(TicketHistory.THID) AS MaxTHID
            FROM 
                TicketHistory
                 Where  TicketHistory.DegreeID is not null or TicketHistory.TransferTo is not null
            GROUP BY 
                TicketHistory.TicketID
        ) th_max ON t.TicketID = th_max.TicketID
    LEFT JOIN 
        TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
    WHERE 
        1=1
        $RD5filters 
        $ReferenceNoa 
        $Codea 
        $TicketIDa 
        $TicketsUsersa 
        $Creatorsa 
        $Degreesa 
        $IsDate 
        $Viewperm 
        $Stages 
        $TicketTypes 
        $Deleted  
    ORDER BY 
        t.TicketID DESC 
    LIMIT 
        $start, $limit
");

    } else {
        $query = "SELECT COUNT(t.TicketID) as num 
        FROM 
            Ticket t
        JOIN 
            projects p ON t.ProjectID = p.ProjectID 
        JOIN 
            (
                SELECT 
                    TicketHistory.TicketID, 
                    MAX(TicketHistory.THID) AS MaxTHID
                FROM 
                    TicketHistory
                       Where  TicketHistory.DegreeID is not null or TicketHistory.TransferTo is not null
                GROUP BY 
                    TicketHistory.TicketID
            ) th_max ON t.TicketID = th_max.TicketID
        JOIN 
            TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
        WHERE 
            th.`UpdaterID` = '$Updaters'
            $RD5filters 
            $ReferenceNoa 
            $Codea 
            $TicketIDa 
            $TicketsUsersa 
            $Creatorsa 
            $Degreesa 
            $IsDate 
            $Viewperm 
            $Stages 
            $TicketTypes 
            $Deleted  
        ORDER BY 
            th.THID DESC, t.TicketID DESC ";
        $total_pages = mysqli_fetch_array($mysqli->query($query));
        $total_pages = $total_pages['num'];

        $limit = 25;
        if ($Page) {
            $start = ($Page - 1) * $limit;
        } else {
            $start = 0;
        }

        $res = $mysqli->query("
        SELECT 
                th.`THID`,th.`CommentEN`,th.`CommentAR`,th.`CorrectiveEN`,th.`CorrectiveAR`,th.`TransferTo`,th.`UpdaterID`,th.`DegreeID`,th.`File`,
            t.TicketID, 
            t.ProjectID, 
            t.TransferTo as TT,
            t.StageID, 
            t.Description,  
            t.UserID, 
            t.Code, 
            t.CreatedAt, 
            p.OwnerID as OID, 
            p.ConstructorID as CID,
            p.ReferenceNo 
        FROM 
            Ticket t
        JOIN 
            projects p ON t.ProjectID = p.ProjectID 
        JOIN 
            (
                SELECT 
                    TicketHistory.TicketID, 
                    MAX(TicketHistory.THID) AS MaxTHID
                FROM 
                    TicketHistory
                       Where  TicketHistory.DegreeID is not null or TicketHistory.TransferTo is not null
                GROUP BY 
                    TicketHistory.TicketID
            ) th_max ON t.TicketID = th_max.TicketID
        JOIN 
            TicketHistory th ON th.TicketID = th_max.TicketID AND th.THID = th_max.MaxTHID
        WHERE 
            th.`UpdaterID` = '$Updaters'
            $RD5filters 
            $ReferenceNoa 
            $Codea 
            $TicketIDa 
            $TicketsUsersa 
            $Creatorsa 
            $Degreesa 
            $IsDate 
            $Viewperm 
            $Stages 
            $TicketTypes 
            $Deleted  
        ORDER BY 
            th.THID DESC, t.TicketID DESC 
        LIMIT 
            $start, $limit
    ");
    }

    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
        while ($row = $res->fetch_assoc()) {
            
            if(is_numeric($row['TransferTo'])){
                $TransferTo = $row['TransferTo'];
            }else{
                $TransferTo = $row['TT'];
            }
            $return[$row['TicketID']]['TicketID'] = $row['TicketID'];
            $return[$row['TicketID']]['StageID'] = $row['StageID'];
            $return[$row['TicketID']]['TransferTo'] = $TransferTo;
            $resx8r = $mysqli->query("SELECT StageName, Category FROM `stages` where `StageID` = '" . $row['StageID'] . "'");
            $row8r = mysqli_fetch_array($resx8r);
            $return[$row['TicketID']]['StageName'] = $row8r['StageName'];
            $return[$row['TicketID']]['StageCategory'] = $row8r['Category'];
            $return[$row['TicketID']]['ProjectID'] = $row['ProjectID'];
            $return[$row['TicketID']]['CreatorID'] = $row['UserID'];
            $return[$row['TicketID']]['Code'] = $row['Code'];
            $return[$row['TicketID']]['DegreeID'] = $row['DegreeID'];
            $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OID'] . "'");
            $row11 = mysqli_fetch_array($resx11);
            $return[$row['TicketID']]['OwnerMobile'] = $row11['Mobile'];
            $return[$row['TicketID']]['OwnerEmail'] = $row11['Email'];
            $return[$row['TicketID']]['OwnerName'] = $row11['Name'];
            $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['CID'] . "'");
            $row12 = mysqli_fetch_array($resx12);
            $return[$row['TicketID']]['ConstructorMobile'] = $row12['Mobile'];
            $return[$row['TicketID']]['ConstructorEmail'] = $row12['Email'];
            $return[$row['TicketID']]['ConstructorName'] = $row12['Name'];
            $resx81r = $mysqli->query("SELECT Name, Category FROM `tickets_degree` where `DegreeID` = '" . $row['DegreeID'] . "'");
            $row81r = mysqli_fetch_array($resx81r);
            $return[$row['TicketID']]['DegreeName'] = $row81r['Name'];
            $return[$row['TicketID']]['DegreeCategory'] = $row81r['Category'];
            $resx88r = $mysqli->query("SELECT Name FROM `role_resources` where `ResourceID` = '$TransferTo'");
            $row88r = mysqli_fetch_array($resx88r);
            $return[$row['TicketID']]['TransferToName'] = $row88r['Name'];
            $return[$row['TicketID']]['Description'] = $row['CommentEN'];
            $return[$row['TicketID']]['CommentEN'] = $row['CommentEN'];
            $return[$row['TicketID']]['CommentAR'] = $row['CommentAR'];
            $return[$row['TicketID']]['CorrectiveEN'] = $row['CorrectiveEN'];
            $return[$row['TicketID']]['CorrectiveAR'] = $row['CorrectiveAR'];
            $return[$row['TicketID']]['CreatedAt'] = $row['CreatedAt'];
            $res11 = $mysqli->query("SELECT `TicketID` FROM `Ticket` WHERE `TicketID` =  '" . $row['TicketID'] . "' AND `Code` BETWEEN'TI500'AND'TI999' AND `Deleted` = '0'");
            $numrows11 = mysqli_num_rows($res11);
            if ($numrows11 != 0) {
                $return[$row['TicketID']]['Deletable'] = true;
            } else {
                $return[$row['TicketID']]['Deletable'] = false;
            }

            $resx81r220 = $mysqli->query("SELECT `Token` FROM `rd5_reports` WHERE `TicketID` = '" . $row['TicketID'] . "'");
            $row81r220 = mysqli_fetch_array($resx81r220);
            $return[$row['TicketID']]['RD5Token'] = $row81r220['Token'];
            $r888244 = $mysqli->query("SELECT ReportID, Status FROM `rd5_reports` where `TicketID` = '" . $row['TicketID'] . "' limit 1");
            $r99ow84 = mysqli_fetch_array($r888244);
            $return[$row['TicketID']]['RD5ReportID'] = $r99ow84['ReportID'];
            $return[$row['TicketID']]['ReferenceNo'] = $row['ReferenceNo'];
            $resx821 = $mysqli->query("SELECT TicketID FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "'");
            $n53321 = mysqli_num_rows($resx821);
            $resx8244 = $mysqli->query("SELECT DegreeID FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "' and `DegreeID` is not NULL");
            $row84 = mysqli_fetch_array($resx8244);
            if ($n53321 > 1) {
                $isEdited = false;
            } else {
                $isEdited = true;
            }
            if ($row84['DegreeID']) {
                $isDegreeEdited = true;
            } else {
                $isDegreeEdited = false;
            }
            $return[$row['TicketID']]['TicketEditedCounter'] = $n53321;
            $return[$row['TicketID']]['TicketEdited'] = $isEdited;
            $return[$row['TicketID']]['DegreeEdited'] = $isDegreeEdited;
            $resx8 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $row['UserID'] . "'");
            $row8 = mysqli_fetch_array($resx8);
            $n55671 = mysqli_num_rows($resx8);
            $resx955 = $mysqli->query("SELECT UpdaterID , CreatedAt FROM `TicketHistory` where `TicketID` = '" . $row['TicketID'] . "' and `CreatedAt` != '".$row['CreatedAt']."' order by THID desc limit 1");
            $ro5967 = mysqli_fetch_array($resx955);

            $return[$row['TicketID']]['LastUpdate'] = $ro5967['CreatedAt'];
            //and (`Type` is null or `Type` != '2')
            $resx9 = $mysqli->query("SELECT FirstName, LastName FROM `users` where `UserID` = '" . $ro5967['UpdaterID'] . "'");
            $row967 = mysqli_fetch_array($resx9);
            $n56722 = mysqli_num_rows($resx9);
            if ($n55671 != 0) {
                $return[$row['TicketID']]['CreatorName'] = $row8['FirstName'] . " " . $row8['LastName'];
            }
            if ($n56722 != 0) {
                $return[$row['TicketID']]['UpdaterName'] = $row967['FirstName'] . " " . $row967['LastName'];
            } else {
                $return[$row['TicketID']]['UpdaterName'] = NULL;
            }
        }
        $lastpage = ceil($total_pages / $limit);
        $return["TotalItems"] = $total_pages;
        $return["TotalPages"] = $lastpage;
        $return["Page"] = $Page;
        $return["error"] = false;
    } else {
        $return["error"] = true;
        $return["message"] = "Not Found!";
    }
}

header('Content-Type: application/json');
echo json_encode($return);
