<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

ob_start('ob_gzhandler');
include('../api/config.php');

require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/Exception.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/PHPMailer.php';
require '../../inspection.cpvarabia.com/wordlib/phpmailer/src/SMTP.php';
require '../../inspection.cpvarabia.com/wordlib/vendor/autoload.php';

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$PStageID = trim($Data->PStageID);
$Status = trim($Data->Status);
$RejectReason = trim($Data->RejectReason);
$Last15Min = date('Y-m-d H:i:s', strtotime('-15 minutes'));
$TodayIs = date("Y-m-d H:i:s");

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
  $return["error"] = true;
  $return["message"] = "Access denied!";
} else {

  $res = $mysqli->query("select PStageID from `project_stages` where `PStageID` in ($PStageID) and `Deleted` = '0'");
  $numrows = mysqli_num_rows($res);
  if ($numrows != 0) {
    if ($Status == "Approved") {
      $res1 = $mysqli->query("SELECT `ProjectID`,`StageID` FROM `project_stages` WHERE `PStageID` = '$PStageID'");
      $row1 = mysqli_fetch_array($res1);
      $TProjectID = $row1['ProjectID'];
      $TStageID = $row1['StageID'];

      $res2 = $mysqli->query("SELECT MAX(`Rev`) as Rev FROM `project_stages` WHERE `ProjectID` = '$TProjectID' and StageID  = '10'");
      $row2 = mysqli_fetch_array($res2);
      $rev = (!is_numeric($row2['Rev'])) ? " , `Rev` = '0' " : " , `Rev` = '" . ($row2['Rev'] + 1) . "'";


      $mysqli->query("UPDATE `project_stages` SET `Status` = 'Approved', `LastUpdate` = '$TodayIs' $rev WHERE `PStageID` IN ($PStageID)");
      $mysqli->query("INSERT INTO `TicketCorn`(`ProjectID`, `StageID`, `CreatedAt`, `Type`) VALUES ('$TProjectID','$TStageID','$Last15Min', 'ADD')");
      $return["SQLerror"] = $mysqli->error;
    } else if ($Status == "Rejected") {

      $mysqli->query("update `project_stages` set `Status` = '$Status', `LastUpdate` = '$TodayIs' where `PStageID` in ($PStageID) ");

      $res5 = $mysqli->query("SELECT projects.ReferenceNo , `project_stages`.`InspectorID` FROM `project_stages`,projects WHERE `project_stages`.`ProjectID` = projects.ProjectID AND `PStageID` = '$PStageID' limit 1");
      while ($row5 = mysqli_fetch_array($res5)) {
          $ReferenceNo = $row5['ReferenceNo'];
          $InspectorID = $row5['InspectorID'];
          $resx10 = $mysqli->query("SELECT `Email`,`FirstName` , `LastName` FROM `users` WHERE `UserID` = '$InspectorID'");
      $row10 = mysqli_fetch_array($resx10);
      $Inspectormail = $row10['Email'];
       $FirstName = $row10['FirstName'];
       $LastName = $row10['LastName'];
      }
      
      $resx10 = $mysqli->query("SELECT `Email` FROM `users` WHERE `UserID` = '$PerUserID'");
      $row10 = mysqli_fetch_array($resx10);
      $reviewer = $row10['Email'];

      $mail = new PHPMailer(true);

      try {
        //Server settings
        $mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
        $mail->isSMTP();                                            //Send using SMTP
        $mail->Host       = 'mail.cpvarabia.com';                     //Set the SMTP server to send through
        $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
        $mail->Username   = 'notify.cpv@cpvarabia.com';                     //SMTP username
        $mail->Password   = 'O06$zJ@CrJ4@';                               //SMTP password
        $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
        $mail->Port       = 465;                                    //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
        $mail->CharSet = 'UTF-8';

        //Recipients
        $mail->setFrom('notify.cpv@cpvarabia.com', 'CPV Arabia Tools');
        $mail->addAddress($Inspectormail);
        $mail->addCC($reviewer);
        $mail->addBCC('notify.cpv@cpvarabia.com');

        //Content
        $mail->isHTML(true);                                  //Set email format to HTML
        $mail->Subject = 'RD0 Report Reject #' . $ReferenceNo;
        $mail->Body = '';

        $mail->Body .= '
    <p>Dear Eng, ' . $FirstName . ' '. $LastName . '<br />
   This is to inform you that report #' . $ReferenceNo . ' has been rejected by your direct manager due to the following reasons: <br />
   ' . $RejectReason . ' .<br />
   So, kindly modify and re-submit the RD0 Report..<br />
   Best regards<br />
    CPVARABIA<br />';

       $mail->send();
        
        $return["error"] = false;
      } catch (Exception $e) {
        $return["error"] = true;
        $return["message"] = "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
      }
   
    } else {
      $mysqli->query("update `project_stages` set `Status` = '$Status', `LastUpdate` = '$TodayIs' where `PStageID` in ($PStageID) ");
    }
    $return["error"] = false;
    $return["message"] = $revNumber;
  } else {
    $return["error"] = true;
    $return["message"] = "Not found!";
  }
}

header('Content-Type: application/json');
echo json_encode($return);
