<?php
ob_start('ob_gzhandler');
include('../../api/config.php');

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$Page = trim($Data->Page);
$Ref = trim($Data->ReferenceNo);
$Date = trim($Data->Date);
$Stage = trim($Data->Stage);
$UserID = trim($Data->Inspector);
$StartDate = trim($Data->StartDate);
$EndDate = trim($Data->EndDate);
$Category = trim($Data->Category);
$Classification = trim($Data->Classification);
$Area = trim($Data->Area);
$Type = trim($Data->Type);
$Deleted = trim($Data->Deleted);
$Contracted = trim($Data->Contracted);
$Last5Days = date('Y-m-d H:i:s', strtotime('-3 days'));

$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' and `Token` = '$PerToken' limit 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
  $return["error"] = true;
  $return["message"] = "Access denied!";
} else {

  if (empty($Page)) {
    $Page = 1;
  } else {
    $Page = $Data->Page;
  }
  if (empty($Ref)) {
    $RefNo = ' ';
  } else {
    $RefNo = " and projects.ReferenceNo  in ($Ref) ";
  }
  if (empty($Category)) {
    $CategoryID = ' ';
  } else {
    $CategoryID = " and `projects`.`CategoryID`  in ($Category) ";
  }
  if (empty($Classification)) {
    $Classifications = ' ';
  } else {
    $Classifications = " and `projects`.`Special`  in ($Classification) ";
  }
  if (empty($Type)) {
    $Types = ' ';
  } else {
    $Type = "'" . str_replace(",", "','", $Type) . "'";
    $Types = " and `projects`.`ProjectType`  in ($Type) ";
  }
  if ($Deleted == true) {
    $Deleteds = " and `project_stages`.`Deleted`  = '1' ";
  } else  if ($Deleted == false) {
    $Deleteds = " and `project_stages`.`Deleted`  = '0' ";
  }


  if (empty($Stage)) {
    $Stages = ' ';
  } else {
    $Stages = " and project_stages.StageID = '$Stage' ";
  }
  if (empty($UserID)) {
    $UserIDsis = ' ';
  } else {
    $UserIDsis = " and project_stages.InspectorID in ($UserID) ";
  }
  if (empty($StartDate) && empty($EndDate)) {
    $IsDate = ' ';
  } else {
    $IsDate = " and `project_stages`.`StageDate` between '$StartDate 00:00:00' and '$EndDate 23:59:59' ";
  }

  if ($Contracted == true and !empty($Ref)) {
    $res144 = $mysqli->query("SELECT `ConstructorID` FROM `projects` WHERE `ReferenceNo` IN ($Ref) AND `Deleted` = '0'");
    $constructorIDs = array();
    while ($row144 = $res144->fetch_assoc()) {
      $constructorIDs[] = $row144['ConstructorID'];
    }
    if (count($constructorIDs) > 1) {
      $constructorID = implode(',', $constructorIDs);
    } else if (count($constructorIDs) == 1) {
      $constructorID = $constructorIDs[0];
    }

    $query = "SELECT COUNT(project_stages.PStageID) as num from project_stages, projects WHERE project_stages.ProjectID = projects.ProjectID and project_stages.StageID in (61,60, 48, 41, 56, 57, 58, 59,  6, 5, 4,7,3) and `projects`.`ConstructorID` in ('$constructorID') $IsDate $Dateis $Stages $UserIDsis $CategoryID $Deleteds $Types $Classifications and project_stages.Token is not null and `project_stages`.`Deleted`  = '0' order by project_stages.PStageID DESC";
    $total_pages = mysqli_fetch_array($mysqli->query($query));
    $total_pages = $total_pages['num'];

    $limit = 25;
    if ($Page) {
      $start = ($Page - 1) * $limit;
    } else {
      $start = 0;
    }

    $res = $mysqli->query("SELECT project_stages.* from project_stages, projects WHERE project_stages.ProjectID = projects.ProjectID and project_stages.StageID in (61,60, 48, 41, 56, 57, 58, 59, 6, 5, 4,7, 3) and `projects`.`ConstructorID` in ('$constructorID') $IsDate $Dateis $Stages $UserIDsis $CategoryID $Deleteds $Types $Classifications and project_stages.Token is not null and `project_stages`.`Deleted`  = '0' order by project_stages.PStageID DESC LIMIT $start, $limit");
  } else {
    $query = "SELECT COUNT(project_stages.PStageID) as num from project_stages, projects WHERE project_stages.ProjectID = projects.ProjectID and project_stages.StageID in (61,60, 48, 41, 56, 57, 58, 59,  6, 5, 4,7, 3) $IsDate $RefNo $Dateis $Stages $UserIDsis $CategoryID $Deleteds $Types $Classifications and project_stages.Token is not null order by project_stages.PStageID DESC";
    $total_pages = mysqli_fetch_array($mysqli->query($query));
    $total_pages = $total_pages['num'];

    $limit = 25;
    if ($Page) {
      $start = ($Page - 1) * $limit;
    } else {
      $start = 0;
    }

    $res = $mysqli->query("SELECT project_stages.* from project_stages, projects WHERE project_stages.ProjectID = projects.ProjectID and project_stages.StageID in (61,60, 48, 41, 56, 57, 58, 59, 6, 5, 4,7, 3) $IsDate $RefNo $Dateis $Stages $UserIDsis $CategoryID $Deleteds $Types $Classifications and project_stages.Token is not null order by project_stages.PStageID DESC LIMIT $start, $limit");
  }
  $numrows = mysqli_num_rows($res);
  if ($numrows > 0) {
    $return["error"] = false;
    $ddd = 0;
    while ($row209 = $res->fetch_assoc()) {
      $resx209 = $mysqli->query("SELECT * FROM `projects` where `ProjectID` = '" . $row209['ProjectID'] . "'");
      $row = mysqli_fetch_array($resx209);
      $resx3 = $mysqli->query("SELECT * FROM `users` where `UserID` = '" . $row209['InspectorID'] . "'");
      $row3 = mysqli_fetch_array($resx3);
      $resx2 = $mysqli->query("SELECT `Name` FROM `building_category` WHERE `BCID`= '" . $row['CategoryID'] . "'");
      $row2 = mysqli_fetch_array($resx2);
      // $resx4 = $mysqli->query("SELECT COUNT(`PStageID`) as Tnum FROM `project_tickets` WHERE `PStageID` = '" . $row209['PStageID'] . "' AND (`DegreeID` IS NULL AND `TransferTo` <> '201') ");
      // $row4 = mysqli_fetch_array($resx4);
      $resx44 = $mysqli->query("SELECT * FROM `stages` where `StageID` = '" . $row209['StageID'] . "'");
      $row34 = mysqli_fetch_array($resx44);
      $res5 = $mysqli->query("SELECT `Name`, `project_locations`.`Region` FROM `Region_Cost`, `project_locations` WHERE `Region_Cost`.`RCID` = `project_locations`.`Region` AND `project_locations`.`ProjectID` = '" . $row209['ProjectID'] . "'");
      $row5 = mysqli_fetch_array($res5);
      $resx11 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['OwnerID'] . "'");
      $row11 = mysqli_fetch_array($resx11);
      $return[$ddd]['OwnerMobile'] = $row11['Mobile'];
      $return[$ddd]['OwnerEmail'] = $row11['Email'];
      $return[$ddd]['OwnerName'] = $row11['Name'];
      $resx12 = $mysqli->query("SELECT Mobile, Email, Name FROM `project_users` where `PUID` = '" . $row['ConstructorID'] . "'");
      $row12 = mysqli_fetch_array($resx12);
      $return[$ddd]['ConstructorMobile'] = $row12['Mobile'];
      $return[$ddd]['ConstructorEmail'] = $row12['Email'];
      $return[$ddd]['ConstructorName'] = $row12['Name'];
      $return[$ddd]['PStageID'] = $row209['PStageID'];
      $return[$ddd]['StageID'] = $row209['StageID'];

      $StageName1 = preg_replace("/\s+/", "", $row34['StageName']);

      if ($row209['StageDate'] >= $Last5Days) {
        if ($row209['StageID'] == '4') {
          $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Column.php?PStageID=' . $row209['PStageID'];
          $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Column.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
        } else if ($row209['StageID'] == '6') {
          $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Waterproofing.php?PStageID=' . $row209['PStageID'];
          $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Waterproofing.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
        } else if ($row209['StageID'] == '3') {
          $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Foundation.php?PStageID=' . $row209['PStageID'];
          $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Foundation.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
        } else if ($row209['StageID'] == '60') {
          $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_SteelStructure.php?PStageID=' . $row209['PStageID'];
          $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_SteelStructure.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
        } else if ($row209['StageID'] == '5') {
          $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Slab.php?PStageID=' . $row209['PStageID'];
          $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Slab.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
        } else {
          $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/ins.php?PStageID=' . $row209['PStageID'];
          $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/ins.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
        }
      } else {
        if ($row209['Status'] == 'Pending') {
          if ($row209['StageID'] == '4') {
            $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Column.php?PStageID=' . $row209['PStageID'];
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Column.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
          } else if ($row209['StageID'] == '6') {
            $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Waterproofing.php?PStageID=' . $row209['PStageID'];
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Waterproofing.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
          } else if ($row209['StageID'] == '3') {
            $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Foundation.php?PStageID=' . $row209['PStageID'];
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Foundation.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
          } else if ($row209['StageID'] == '60') {
            $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_SteelStructure.php?PStageID=' . $row209['PStageID'];
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_SteelStructure.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
          } else if ($row209['StageID'] == '5') {
            $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Slab.php?PStageID=' . $row209['PStageID'];
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Slab.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
          } else {
            $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/ins.php?PStageID=' . $row209['PStageID'];
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/ins.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
          }
        } else {
          $link = 'https://cpv.blr1.digitaloceanspaces.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_' . $StageName1 . '_' . $row209['PStageID'] . '.docx';
          if (@file_get_contents($link)) {
            $return[$ddd]['WORD'] = 'https://cpv.blr1.digitaloceanspaces.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_' . $StageName1 . '_' . $row209['PStageID'] . '.docx';
          } else {
            if ($row209['StageID'] == '4') {
              $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Column.php?PStageID=' . $row209['PStageID'];
            } else if ($row209['StageID'] == '6') {
              $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Waterproofing.php?PStageID=' . $row209['PStageID'];
            } else if ($row209['StageID'] == '3') {
              $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Foundation.php?PStageID=' . $row209['PStageID'];
            } else if ($row209['StageID'] == '60') {
              $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_SteelStructure.php?PStageID=' . $row209['PStageID'];
            } else if ($row209['StageID'] == '5') {
              $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Slab.php?PStageID=' . $row209['PStageID'];
            } else {
              $return[$ddd]['WORD'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/ins.php?PStageID=' . $row209['PStageID'];
            }
          }
          $pdflink = 'https://inspection.cpvarabia.com/pdf/Ref_' . $row['ReferenceNo'] . '_S_' . $StageName1 . '_' . $row209['PStageID'] . '.pdf';
          if (@file_get_contents($pdflink)) {
            $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/pdf/Ref_' . $row['ReferenceNo'] . '_S_' . $StageName1 . '_' . $row209['PStageID'] . '.pdf';
          } else {
            if ($row209['StageID'] == '4') {
              $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Column.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
            } else if ($row209['StageID'] == '6') {
              $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Waterproofing.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
            } else if ($row209['StageID'] == '3') {
              $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Foundation.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
            } else if ($row209['StageID'] == '60') {
              $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_SteelStructure.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
            } else if ($row209['StageID'] == '5') {
              $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/Inspection_Slab.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
            } else {
              $return[$ddd]['PDF'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/ins.php?PStageID=' . $row209['PStageID'] . '&PDF=2';
            }
          }
        }
      }




      if ($row209['RResult'] == 1) {
        $RResult = 'RD5 WI';
      } else if ($row209['RResult'] == 2) {
        $RResult = 'RD5 MS';
      } else if ($row209['RResult'] == 3 or $row209['RResult'] == 4) {
        $RResult = 'Additional Vsit';
      } else if ($row209['RResult'] == 5) {
        $RResult = 'Satisfactory with Technical Reservation';
      } else if ($row209['RResult'] == 6) {
        $RResult = 'Satisfactory with Note';
      } else {
        $RResult = 'Satisfactory';
      }
      $return[$ddd]['$Contracted'] = $constructorID;
      $return[$ddd]['Status'] = $RResult;
      $return[$ddd]['RStatus'] = $row209['Status'];

      $return[$ddd]['InspectorID'] = $row209['InspectorID'];
      $return[$ddd]['StageDate'] = $row209['StageDate'];
      $return[$ddd]['MissingData'] = $row209['MissingData'];
      $return[$ddd]['Synced'] = $row209['Synced'];
      $return[$ddd]['ProjectID'] = $row['ProjectID'];
      $return[$ddd]['ReferenceNo'] = $row['ReferenceNo'];
      $return[$ddd]['Area'] = $row5['Name'];
      $coordinates = str_replace('|', ',', $row209['Location']);
      $return[$ddd]['Location'] = $coordinates;
      $return[$ddd]['FullName'] = $row3['FirstName'] . " " . $row3['LastName'];
      $return[$ddd]['Category'] = $row2['Name'];
      //$return[$ddd]['Tnum'] = $row4['Tnum'];
      $return[$ddd]['StageName'] = $row34['StageName'];

      $ddd++;
    }
    $res11 = $mysqli->query("SELECT `OCID` FROM `org_chart` WHERE `Supervisor` ='$PerUserID'");
    $numrows1 = mysqli_num_rows($res11);
    if ($numrows1 > 0) {
      $return['IsAreaManager'] = true;
    } else {
      $return['IsAreaManager'] = false;
    }
    $lastpage = ceil($total_pages / $limit);
    $return["TotalItems"] = $total_pages;
    $return["TotalPages"] = $lastpage;
    $return["Page"] = $Page;
  } else {
    $return["error"] = true;
    $return["message"] = "Incorrect!";
  }
}

header('Content-Type: application/json');
echo json_encode($return);
